#ifndef GUI_CONFIG___FEAT_SHOW__HPP
#define GUI_CONFIG___FEAT_SHOW__HPP

/*  $Id: feat_show.hpp 14562 2007-05-18 11:48:21Z dicuccio $
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 * Authors:  Robert Smith
 *
 */

/// @file feat_show.hpp


#include <corelib/ncbistd.hpp>
#include <gui/gui_export.h>


/** @addtogroup GUI_CONFIG
 *
 * @{
 */


BEGIN_NCBI_SCOPE

///
/// CFeatConfigShow - class to hold a boolean value (show or not) for features.
///
/// Associates a boolean value with each feature type/subtype, which values
/// can be inherited from those associated with 'master' feature types.

class CSettingsSet;

class NCBI_GUICONFIG_EXPORT CFeatConfigShow  {
public:
    CFeatConfigShow(CSettingsSet& settings);

    bool        GetShow(int subtype) const;
    void        SetShow(int subtype, bool show);
protected:
    CSettingsSet& m_Settings;
};


END_NCBI_SCOPE


/* @} */

#endif  /* GUI_CONFIG___FEAT_SHOW__HPP */
