#ifndef GUI_CORE_DEMO___OBJECT_LOADING_TASK__HPP
#define GUI_CORE_DEMO___OBJECT_LOADING_TASK__HPP

/*  $Id: object_loading_task.hpp 26758 2012-11-02 16:27:30Z katargir $
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 * Authors: Roman Katargin
 *
 * File Description:
 *
 */

#include <corelib/ncbistl.hpp>

#include <gui/core/loading_app_job.hpp>

#include <gui/utils/object_loader.hpp>

BEGIN_NCBI_SCOPE

class NCBI_GUICORE_EXPORT  CObjectLoadingTask : public CAppJobTask
{
public:
    CObjectLoadingTask(CDataLoadingJob& job, IObjectLoader& object_loader);

    /// @name IAppTask interface implementation
    /// @{
    virtual ETaskState Run();
    /// @}

private:
    CIRef<IObjectLoader>   m_ObjectLoader;
    CRef<CDataLoadingJob>  m_DataLoadingJob;
    bool m_ObjectsLoaded;
};

END_NCBI_SCOPE


#endif // GUI_CORE_DEMO___OBJECT_LOADING_TASK__HPP
