/* $Id: FolderInfo.hpp 14666 2007-07-09 13:40:22Z dicuccio $
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 */

/// @FolderInfo.hpp
/// User-defined methods of the data storage class.
///
/// This file was originally generated by application DATATOOL
/// using the following specifications:
/// 'gui_project.asn'.
///
/// New methods or data members can be added to it if needed.
/// See also: FolderInfo_.hpp


#ifndef GUI_CORE_FOLDERINFO_HPP
#define GUI_CORE_FOLDERINFO_HPP


// generated includes
#include <gui/objects/FolderInfo_.hpp>

// generated classes

BEGIN_NCBI_SCOPE

class CTime;

BEGIN_objects_SCOPE // namespace ncbi::objects::

/////////////////////////////////////////////////////////////////////////////
class NCBI_GUIOBJECTS_EXPORT CFolderInfo : public CFolderInfo_Base
{
    typedef CFolderInfo_Base Tparent;
public:
    // constructor
    CFolderInfo(void);
    // destructor
    ~CFolderInfo(void);

    void SetCreateDate(const CTime& time);
    void SetCreateDate(const CDate& time);

private:
    // Prohibit copy constructor and assignment operator
    CFolderInfo(const CFolderInfo& value);
    CFolderInfo& operator=(const CFolderInfo& value);

};

/////////////////// CFolderInfo inline methods

// constructor
inline
CFolderInfo::CFolderInfo(void)
{
    SetOpen(true);
}


/////////////////// end of CFolderInfo inline methods


END_objects_SCOPE // namespace ncbi::objects::

END_NCBI_SCOPE

#endif // GUI_CORE_FOLDERINFO_HPP
/* Original file checksum: lines: 94, chars: 2573, CRC32: e7f2e71f */
