#ifndef GUI_OBJUTILS___UTIL_CMDS__HPP
#define GUI_OBJUTILS___UTIL_CMDS__HPP

/*  $Id: util_cmds.hpp 28183 2013-05-21 19:33:28Z bollin $
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 * Authors: Colleen Bollin
 *
 * File Description:
 *
 */


#include <corelib/ncbiobj.hpp>
#include <gui/gui_export.h>

#include <objmgr/seq_feat_handle.hpp>
#include <objmgr/bioseq_handle.hpp>
#include <objmgr/seq_entry_handle.hpp>

#include <gui/objutils/undo_manager_interface.hpp>
#include <gui/objutils/cmd_composite.hpp>

BEGIN_NCBI_SCOPE


NCBI_GUIOBJUTILS_EXPORT CRef<CCmdComposite> GetDeleteFeatureCommand(const objects::CSeq_feat_Handle& fh);
NCBI_GUIOBJUTILS_EXPORT CRef<CCmdComposite> GetDeleteSequenceCommand(objects::CBioseq_Handle bsh);
NCBI_GUIOBJUTILS_EXPORT CRef<CCmdComposite> GetDeleteAllFeaturesCommand(objects::CSeq_entry_Handle seh, size_t& count);

NCBI_GUIOBJUTILS_EXPORT CRef<CCmdComposite> TaxonomyLookupCommand(objects::CSeq_entry_Handle seh);

END_NCBI_SCOPE

#endif  // GUI_OBJUTILS___UTIL_CMDS__HPP



