#ifndef PKG_ALIGNMENT___RM_LOAD_JOB__HPP
#define PKG_ALIGNMENT___RM_LOAD_JOB__HPP

/*  $Id: rm_load_job.hpp 25153 2012-01-26 20:34:18Z katargir $
* ===========================================================================
*
*                            PUBLIC DOMAIN NOTICE
*               National Center for Biotechnology Information
*
*  This software/database is a "United States Government Work" under the
*  terms of the United States Copyright Act.  It was written as part of
*  the author's official duties as a United States Government employee and
*  thus cannot be copyrighted.  This software/database is freely available
*  to the public for use. The National Library of Medicine and the U.S.
*  Government have not placed any restriction on its use or reproduction.
*
*  Although all reasonable efforts have been taken to ensure the accuracy
*  and reliability of the software and data, the NLM and the U.S.
*  Government do not and cannot warrant the performance or results that
*  may be obtained by using this software or data. The NLM and the U.S.
*  Government disclaim all warranties, express or implied, including
*  warranties of performance, merchantability or fitness for any particular
*  purpose.
*
*  Please cite the author in any work or product based on this material.
*
* ===========================================================================
*
* Authors:  Roman Katargin
*
* File Description:
*
*/

#include <corelib/ncbistd.hpp>

#include <gui/core/loading_app_job.hpp>

BEGIN_NCBI_SCOPE


/** @addtogroup GUI_PKG_SEQUENCE
*
* @{
*/

///////////////////////////////////////////////////////////////////////////////
/// CRMLoadJob
class  CRMLoadJob : public CDataLoadingAppJob
{
public:
    CRMLoadJob(CProjectService* service,
        const vector<wxString>& filenames);

protected:
    virtual void    x_CreateProjectItems();

private:
    vector<wxString> m_FileNames;       ///< List of files to load
    wxString         m_CurrentFileName; ///< Current file processed 
};

/* @} */

END_NCBI_SCOPE

#endif // PKG_ALIGNMENT___RM_LOAD_JOB__HPP
