
/*  $Id: remove_sequences.hpp 27542 2013-03-01 18:15:33Z bollin $
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data,  the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties,  express or implied,  including
 *  warranties of performance,  merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 * Authors:  Igor Filippov
 */

#ifndef _REMOVE_SEQUENCES_H_
#define _REMOVE_SEQUENCES_H_

#include <corelib/ncbistd.hpp>
#include <gui/packages/pkg_sequence_edit/bulk_cmd_dlg.hpp>
#include <gui/packages/pkg_sequence_edit/seq_table_grid.hpp>
#include <gui/packages/pkg_sequence_edit/tbl_edit_dlg.hpp>

#include <gui/objutils/undo_manager_interface.hpp>
#include <objects/seq/Seq_inst.hpp>
#include <objmgr/bioseq_handle.hpp>

#include <wx/msgdlg.h>

BEGIN_NCBI_SCOPE

class CRemoveSequencesCommandConverter : public CTableCommandConverter 
{
public:
    virtual ~CRemoveSequencesCommandConverter() {};
    CRemoveSequencesCommandConverter() {m_Grid=NULL;};
    virtual CRef<objects::CSeq_table> GetValuesTableFromSeqEntry(objects::CSeq_entry_Handle seh);
    virtual CRef<CCmdComposite> GetCommandFromValuesTable(CRef<objects::CSeq_table>, objects::CSeq_entry_Handle seh);
    virtual string GetErrorMessage(CRef<objects::CSeq_table>);
    virtual bool IsReadOnlyColumn(string column_name) { return true; };
    void SetGrid(wxGrid* grid) {m_Grid = grid;} //  m_Grid->UseNativeColHeader(true);
private:
    wxGrid* m_Grid;
};

END_NCBI_SCOPE

#endif
    // _REMOVE_SEQUENCES_H_
