#error don't include me
#ifndef GUI_DIALOGS_CONFIG___EDIT_STYLES_DLG__HPP
#define GUI_DIALOGS_CONFIG___EDIT_STYLES_DLG__HPP

/*  $Id: edit_styles_dlg.hpp 25627 2012-04-13 17:44:23Z katargir $
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data,  the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties,  express or implied,  including
 *  warranties of performance,  merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 * Authors:  Roman Katargin
 */

#include <gui/gui.hpp>
#include <corelib/ncbistd.hpp>

#include <wx/dialog.h>

BEGIN_NCBI_SCOPE

class IConfigMediator;

/*!
 * Includes
 */

////@begin includes
////@end includes

/*!
 * Forward declarations
 */

////@begin forward declarations
////@end forward declarations

/*!
 * Control identifiers
 */

////@begin control identifiers
#define SYMBOL_CEDITSTYLESDLG_STYLE wxCAPTION|wxRESIZE_BORDER|wxSYSTEM_MENU|wxCLOSE_BOX
#define SYMBOL_CEDITSTYLESDLG_TITLE _("EditStylesDlg")
#define SYMBOL_CEDITSTYLESDLG_IDNAME ID_CEDITSTYLESDLG
#define SYMBOL_CEDITSTYLESDLG_SIZE wxSize(400, 300)
#define SYMBOL_CEDITSTYLESDLG_POSITION wxDefaultPosition
////@end control identifiers


/*!
 * CEditStylesDlg class declaration
 */

class CEditStylesDlg: public wxDialog
{
    DECLARE_DYNAMIC_CLASS( CEditStylesDlg )
    DECLARE_EVENT_TABLE()

public:
    /// Constructors
    CEditStylesDlg();
    CEditStylesDlg( IConfigMediator& mediator, wxWindow* parent, wxWindowID id = SYMBOL_CEDITSTYLESDLG_IDNAME, const wxString& caption = SYMBOL_CEDITSTYLESDLG_TITLE, const wxPoint& pos = SYMBOL_CEDITSTYLESDLG_POSITION, const wxSize& size = SYMBOL_CEDITSTYLESDLG_SIZE, long style = SYMBOL_CEDITSTYLESDLG_STYLE );

    /// Creation
    bool Create( wxWindow* parent, wxWindowID id = SYMBOL_CEDITSTYLESDLG_IDNAME, const wxString& caption = SYMBOL_CEDITSTYLESDLG_TITLE, const wxPoint& pos = SYMBOL_CEDITSTYLESDLG_POSITION, const wxSize& size = SYMBOL_CEDITSTYLESDLG_SIZE, long style = SYMBOL_CEDITSTYLESDLG_STYLE );

    /// Destructor
    ~CEditStylesDlg();

    /// Initialises member variables
    void Init();

    /// Creates the controls and sizers
    void CreateControls();

////@begin CEditStylesDlg event handler declarations

    /// wxEVT_COMMAND_LISTBOX_SELECTED event handler for ID_LISTBOX1
    void OnListbox1Selected( wxCommandEvent& event );

    /// wxEVT_COMMAND_BUTTON_CLICKED event handler for ID_BUTTON1
    void OnAddClick( wxCommandEvent& event );

    /// wxEVT_COMMAND_BUTTON_CLICKED event handler for ID_BUTTON4
    void OnCopyClick( wxCommandEvent& event );

    /// wxEVT_COMMAND_BUTTON_CLICKED event handler for ID_BUTTON5
    void OnRenameClick( wxCommandEvent& event );

    /// wxEVT_COMMAND_BUTTON_CLICKED event handler for ID_BUTTON6
    void OnDeleteClick( wxCommandEvent& event );

////@end CEditStylesDlg event handler declarations

////@begin CEditStylesDlg member function declarations

    /// Retrieves bitmap resources
    wxBitmap GetBitmapResource( const wxString& name );

    /// Retrieves icon resources
    wxIcon GetIconResource( const wxString& name );
////@end CEditStylesDlg member function declarations

    /// Should we show tooltips?
    static bool ShowToolTips();

////@begin CEditStylesDlg member variables
    /// Control identifiers
    enum {
        ID_CEDITSTYLESDLG = 10000,
        ID_LISTBOX1 = 10001,
        ID_BUTTON1 = 10002,
        ID_BUTTON4 = 10003,
        ID_BUTTON5 = 10004,
        ID_BUTTON6 = 10010
    };
////@end CEditStylesDlg member variables

private:
    CRef<IConfigMediator> m_ConfigMediator;
    void x_UpdateSetBtns();
};

END_NCBI_SCOPE

#endif  // GUI_DIALOGS_CONFIG___EDIT_STYLES_DLG__HPP
