#error don't include me
#ifndef GUI_DIALOGS_CONFIG___FEAT_SHOW_PANEL__HPP
#define GUI_DIALOGS_CONFIG___FEAT_SHOW_PANEL__HPP

/*  $Id: feat_show_panel.hpp 16214 2008-02-29 02:44:06Z dicuccio $
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 * Authors:  Robert G. Smith
 *
 */

/// @file feat_show_panel.hpp
///


#include <corelib/ncbistd.hpp>
#include <gui/gui_export.h>
#include <gui/widgets/config/config_panel.hpp>


/** @addtogroup Miscellaneous
 *
 * @{
 */
BEGIN_NCBI_SCOPE
BEGIN_SCOPE(objects)
class CFeatList;
END_SCOPE(objects)


class CFeatShowExtraItem {
public:
    CFeatShowExtraItem(string desc, int ext_index) :
        m_Desc(desc), m_ExtIndex(ext_index) {};

    string GetDesc() const { return m_Desc; }
    const int & GetExtIndex() const { return m_ExtIndex; }

private:
    string  m_Desc;
    int     m_ExtIndex;

};


class NCBI_GUIWIDGETS_CONFIG_EXPORT CFeatShowPanel : public IConfigPanel
{
public:
    CFeatShowPanel();
    CFeatShowPanel(const  vector<CFeatShowExtraItem> & extras);
    ~CFeatShowPanel();

    virtual wxWindow*   CreateConfigPanel(wxWindow* parent);

    int   GetNumExtras();

private:
    const objects::CFeatList*         m_Feats;
    vector<CFeatShowExtraItem>  m_Extras;
};


END_NCBI_SCOPE


/* @} */

#endif  /* GUI_DIALOGS_CONFIG___FEAT_SHOW_PANEL__HPP */
