#error don't include me
#ifndef GUI_DIALOGS_CONFIG___THEME_CONFIG_PANEL2__HPP
#define GUI_DIALOGS_CONFIG___THEME_CONFIG_PANEL2__HPP

/*  $Id: theme_config_panel2.hpp 16214 2008-02-29 02:44:06Z dicuccio $
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 * Authors:  Robert G. Smith
 *
 */

/// @file theme_config_panel2.hpp
///


#include <corelib/ncbistd.hpp>

#include <gui/widgets/config/theme_config_panel_base.hpp>

class wxPanel;
class wxWindow;

/** @addtogroup Miscellaneous
 *
 * @{
 */
BEGIN_NCBI_SCOPE

class CwxThemeConfigPanel;

class NCBI_GUIWIDGETS_CONFIG_EXPORT CThemeConfigPanel2 : public CThemeConfigPanelBase {
    friend class CwxThemeConfigPanel;
public:
    enum ELayoutDirection {
        eLayoutDirection_Horizontal,
        eLayoutDirection_Vertical
    };

    CThemeConfigPanel2();

    virtual ~CThemeConfigPanel2();


    virtual wxWindow*   CreateConfigPanel(wxWindow* parent);

    virtual void        MakeWidgets();
    virtual void        UpdateWidgets();

    void                SetLayoutDirection(ELayoutDirection);
    ELayoutDirection    GetLayoutDirection();

    /// Where should someone put a preview widget?
    wxPanel*            GetPreviewLocation();
    /// Settings have changed.  The preview widget needs to show the effect of those changes.
    virtual void        UpdatePreview();

private:
    ELayoutDirection    m_LayoutDirection;

};


END_NCBI_SCOPE


/* @} */

#endif  /* GUI_DIALOGS_CONFIG___THEME_CONFIG_PANEL2__HPP */
