#error don't include me
#ifndef GUI_WIDGETS_CONFIG___THEME_DLG__HPP
#define GUI_WIDGETS_CONFIG___THEME_DLG__HPP

/*  $Id: theme_dlg.hpp 25627 2012-04-13 17:44:23Z katargir $
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data,  the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties,  express or implied,  including
 *  warranties of performance,  merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 * Authors:  Roman Katargin
 */

#include <gui/gui.hpp>
#include <corelib/ncbistd.hpp>
#include <gui/widgets/config/iconfig_mediator.hpp>

#include <wx/dialog.h>

BEGIN_NCBI_SCOPE

/*!
 * Forward declarations
 */


////@begin forward declarations
////@end forward declarations

/*!
 * Control identifiers
 */

////@begin control identifiers
#define SYMBOL_CTHEMEDLG_STYLE wxCAPTION|wxRESIZE_BORDER|wxSYSTEM_MENU|wxCLOSE_BOX
#define SYMBOL_CTHEMEDLG_TITLE _("ThemeDlg")
#define SYMBOL_CTHEMEDLG_IDNAME ID_CTHEMEDLG
#define SYMBOL_CTHEMEDLG_SIZE wxSize(400, 300)
#define SYMBOL_CTHEMEDLG_POSITION wxDefaultPosition
////@end control identifiers


/*!
 * CThemeDlg class declaration
 */

class NCBI_GUIWIDGETS_CONFIG_EXPORT CThemeDlg: public wxDialog
{
    DECLARE_DYNAMIC_CLASS( CThemeDlg )
    DECLARE_EVENT_TABLE()

public:
    /// Constructors
    CThemeDlg();
    CThemeDlg( IConfigMediator& mediator, wxWindow* parent, wxWindowID id = SYMBOL_CTHEMEDLG_IDNAME, const wxString& caption = SYMBOL_CTHEMEDLG_TITLE, const wxPoint& pos = SYMBOL_CTHEMEDLG_POSITION, const wxSize& size = SYMBOL_CTHEMEDLG_SIZE, long style = SYMBOL_CTHEMEDLG_STYLE );

    /// Creation
    bool Create( wxWindow* parent, wxWindowID id = SYMBOL_CTHEMEDLG_IDNAME, const wxString& caption = SYMBOL_CTHEMEDLG_TITLE, const wxPoint& pos = SYMBOL_CTHEMEDLG_POSITION, const wxSize& size = SYMBOL_CTHEMEDLG_SIZE, long style = SYMBOL_CTHEMEDLG_STYLE );

    /// Destructor
    ~CThemeDlg();

    /// Initialises member variables
    void Init();

    /// Creates the controls and sizers
    void CreateControls();

////@begin CThemeDlg event handler declarations

    /// wxEVT_COMMAND_CHOICE_SELECTED event handler for ID_CHOICE1
    void OnThemeListSelected( wxCommandEvent& event );

    /// wxEVT_COMMAND_BUTTON_CLICKED event handler for ID_BUTTON2
    void OnShowStateClick( wxCommandEvent& event );

    /// wxEVT_COMMAND_BUTTON_CLICKED event handler for ID_BUTTON3
    void OnDefaultsClick( wxCommandEvent& event );

    /// wxEVT_COMMAND_BUTTON_CLICKED event handler for wxID_OK
    void OnOkClick( wxCommandEvent& event );

    /// wxEVT_COMMAND_BUTTON_CLICKED event handler for wxID_CANCEL
    void OnCancelClick( wxCommandEvent& event );

////@end CThemeDlg event handler declarations

////@begin CThemeDlg member function declarations

    /// Retrieves bitmap resources
    wxBitmap GetBitmapResource( const wxString& name );

    /// Retrieves icon resources
    wxIcon GetIconResource( const wxString& name );
////@end CThemeDlg member function declarations

    /// Should we show tooltips?
    static bool ShowToolTips();

////@begin CThemeDlg member variables
    /// Control identifiers
    enum {
        ID_CTHEMEDLG = 10005,
        ID_CHOICE1 = 10006,
        ID_BUTTON2 = 10007,
        ID_WINDOW = 10008,
        ID_BUTTON3 = 10009
    };
////@end CThemeDlg member variables

private:
    CRef<IConfigMediator> m_ConfigMediator;
    void x_SetStates(list<string> const& states);
    void x_SetLoadedState(const string& theme);
    string x_GetLoadedState();
};

END_NCBI_SCOPE

#endif  // GUI_WIDGETS_CONFIG___THEME_DLG__HPP
