#error don't include me
#ifndef GUI_DIALOGS_CONFIG___THEME_PREVIEW_MEDIATOR__HPP
#define GUI_DIALOGS_CONFIG___THEME_PREVIEW_MEDIATOR__HPP

/*  $Id: theme_preview_mediator.hpp 16214 2008-02-29 02:44:06Z dicuccio $
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 * Authors:  Robert Smith
 *
 * File Description:
 *  CThemePreviewMediator
 *
 *  Communicates between a 'Theme' settings class (data) and a 'Theme' widget
 *  panel (panel), where the data is the configuration for a preview panel
 *  and the widgets are on the same dialog as that panel.
 *
 *  In distinction to most config mediators, this class Only communicates
 *  from the widgets to the data, never back.
 */

#include <gui/widgets/config/config_mediator.hpp> // base class

BEGIN_NCBI_SCOPE

class CThemeSet;
class IThemeConfigPanelBase;


class NCBI_GUIWIDGETS_CONFIG_EXPORT CThemePreviewMediator : public CConfigMediator
{
public:
    CThemePreviewMediator(CThemeSet & data, IThemeConfigPanelBase& panel);
    virtual ~CThemePreviewMediator();

    /// What should we title the dialog window?
    string      GetWindowTitle(void) const;
    /// Load data into that panel
    void                Load(const string& state);
    /// Load 'factory default' data into that panel.
    void                LoadDefault(void);
    /// Save the panel's data.
    void                Save(const string& state);

protected:

// the following accessors are just to hide the ugly down casts.
    CThemeSet&              x_GetMyDataSet(void) ;
    const CThemeSet&        x_GetMyDataSet(void) const;
    IThemeConfigPanelBase&      x_GetMyPanel(void);

};


END_NCBI_SCOPE

#endif  /* GUI_DIALOGS_CONFIG___THEME_PREVIEW_MEDIATOR__HPP */
