#ifndef GUI_WIDGETS_GRID_WIDGET__GRID_EVENT__HPP
#define GUI_WIDGETS_GRID_WIDGET__GRID_EVENT__HPP

/*  $Id: grid_event.hpp 27000 2012-12-05 22:00:56Z katargir $
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 * Authors:  Roman Katargin
 *
 * File Description:
 *
 */

#include <corelib/ncbiobj.hpp>

#include <gui/utils/event.hpp>

BEGIN_NCBI_SCOPE

class CGridWidgetEvent : public CEvent
{
public:
    typedef CEventAttachmentFor<wxString> TAttachment;

    enum EEventType {
        eUrlHover,

        eUnknownEvent = -1
    };

    /// create an event for a given event ID, with event class Unknown
    CGridWidgetEvent(TEventID eid)
        : CEvent(eid)
    {
    }

    /// create an event for a specific event class and ID
    CGridWidgetEvent(TEventClass ecl, TEventID eid)
        : CEvent(ecl, eid)
    {
    }

};

END_NCBI_SCOPE

#endif  // GUI_WIDGETS_GRID_WIDGET__GRID_EVENT__HPP
