#ifndef GUI_WIDGETS_MACRO_EDIT___MACRO_EDIT_DLG__HPP
#define GUI_WIDGETS_MACRO_EDIT___MACRO_EDIT_DLG__HPP

/*  $Id: edit_macro_dlg.hpp 24278 2011-08-31 20:02:27Z katargir $
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data,  the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties,  express or implied,  including
 *  warranties of performance,  merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 * Authors:  
 */

#include <corelib/ncbistd.hpp>
#include <gui/gui_export.h>

#include <gui/widgets/wx/dialog.hpp>

/*!
 * Includes
 */

////@begin includes
////@end includes

/*!
 * Forward declarations
 */

////@begin forward declarations
////@end forward declarations

class wxTextCtrl;

/*!
 * Control identifiers
 */

////@begin control identifiers
#define SYMBOL_CEDITMACRODLG_STYLE wxCAPTION|wxRESIZE_BORDER|wxSYSTEM_MENU|wxCLOSE_BOX|wxTAB_TRAVERSAL
#define SYMBOL_CEDITMACRODLG_TITLE _("Edit Macro")
#define SYMBOL_CEDITMACRODLG_IDNAME ID_CEDITMACRODLG
#define SYMBOL_CEDITMACRODLG_SIZE wxSize(400, 300)
#define SYMBOL_CEDITMACRODLG_POSITION wxDefaultPosition
////@end control identifiers

BEGIN_NCBI_SCOPE


/*!
 * CEditMacroDlg class declaration
 */

class NCBI_GUIWIDGETS_MACRO_EDIT_EXPORT CEditMacroDlg: public CDialog
{    
    DECLARE_DYNAMIC_CLASS( CEditMacroDlg )
    DECLARE_EVENT_TABLE()

public:
    /// Constructors
    CEditMacroDlg();
    CEditMacroDlg( wxWindow* parent, wxWindowID id = SYMBOL_CEDITMACRODLG_IDNAME, const wxString& caption = SYMBOL_CEDITMACRODLG_TITLE, const wxPoint& pos = SYMBOL_CEDITMACRODLG_POSITION, const wxSize& size = SYMBOL_CEDITMACRODLG_SIZE, long style = SYMBOL_CEDITMACRODLG_STYLE );

    /// Creation
    bool Create( wxWindow* parent, wxWindowID id = SYMBOL_CEDITMACRODLG_IDNAME, const wxString& caption = SYMBOL_CEDITMACRODLG_TITLE, const wxPoint& pos = SYMBOL_CEDITMACRODLG_POSITION, const wxSize& size = SYMBOL_CEDITMACRODLG_SIZE, long style = SYMBOL_CEDITMACRODLG_STYLE );

    /// Destructor
    ~CEditMacroDlg();

    /// Initialises member variables
    void Init();

    /// Creates the controls and sizers
    void CreateControls();

////@begin CEditMacroDlg event handler declarations

    /// wxEVT_COMMAND_BUTTON_CLICKED event handler for ID_BUTTON
    void OnParseClick( wxCommandEvent& event );

////@end CEditMacroDlg event handler declarations

////@begin CEditMacroDlg member function declarations

    /// Retrieves bitmap resources
    wxBitmap GetBitmapResource( const wxString& name );

    /// Retrieves icon resources
    wxIcon GetIconResource( const wxString& name );
////@end CEditMacroDlg member function declarations

    /// Should we show tooltips?
    static bool ShowToolTips();

////@begin CEditMacroDlg member variables
    wxTextCtrl* m_TextCtrl;
    /// Control identifiers
    enum {
        ID_CEDITMACRODLG = 10000,
        ID_TEXTCTRL = 10001,
        ID_BUTTON = 10002
    };
////@end CEditMacroDlg member variables
};

END_NCBI_SCOPE

#endif  // GUI_WIDGETS_MACRO_EDIT___MACRO_EDIT_DLG__HPP
