#ifndef GUI_WIDGETS_OBJECT_LIST___OBJECT_TEXT_ITEM__HPP
#define GUI_WIDGETS_OBJECT_LIST___OBJECT_TEXT_ITEM__HPP

/*  $Id: object_text_item.hpp 23748 2011-05-25 18:10:50Z katargir $
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 * Authors:  Roman Katargin
 *
 * File Description:
 *
 */

#include <corelib/ncbistd.hpp>
#include <corelib/ncbiobj.hpp>

#include <gui/widgets/object_list/object_text_params.hpp>
#include <gui/widgets/text_widget/text_select_item.hpp>
#include <gui/widgets/text_widget/text_item_panel.hpp>

BEGIN_NCBI_SCOPE

class CObjectTextItem : public CObject, public CTextSelectItem
{
public:
    virtual int GetTextOffset(CTextPanelContext* context) const
    {
        return context->GetLeftMargin();
    }

    virtual const CConstRef<CObject> GetAssosiatedObject() const { return m_Object; }
    virtual objects::CScope*         GetAssosiatedScope() const { return m_Scope.GetPointer(); }


    SConstScopedObject GetAssosiatedScopedObject() const { return SConstScopedObject(*m_Object, *m_Scope); }

protected:
    CObjectTextItem() {}

    void x_SetObject(CConstRef<CObject> object) { m_Object = object; }
    void x_SetScope(CRef<objects::CScope> scope) { m_Scope = scope; }
    void x_SetContext(CObjectTextParams::Context context) { m_Context = context; }

    CConstRef<CObject> m_Object;
    mutable CRef<objects::CScope> m_Scope;
    CObjectTextParams::Context m_Context;
};

END_NCBI_SCOPE

#endif  // GUI_WIDGETS_OBJECT_LIST___OBJECT_TEXT_ITEM__HPP
