#ifndef GUI_WIDGETS_OBJECT_LIST___OBJECT_TEXT_PARAMS__HPP
#define GUI_WIDGETS_OBJECT_LIST___OBJECT_TEXT_PARAMS__HPP

/*  $Id: object_text_params.hpp 23775 2011-05-27 19:36:24Z katargir $
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 * Authors:  Roman Katargin
 *
 * File Description:
 *
 */

#include <corelib/ncbistd.hpp>
#include <corelib/ncbiobj.hpp>

#include <gui/objutils/interface_registry.hpp>

BEGIN_NCBI_SCOPE

class CObjectTextParams : public ICreateParams
{
public:
    enum Context {
        kBrief,
        kFull
    };

    CObjectTextParams(Context context) : m_Context(context) {}

    virtual  Context GetContext() const { return m_Context; }

protected:
    Context m_Context;
};

END_NCBI_SCOPE

#endif  // GUI_WIDGETS_OBJECT_LIST___OBJECT_TEXT_PARAMS__HPP
