#if !defined(AFX_PHYLO_TREE_RECT_CLADOGRAM_HPP__78D7E7CC_FC75_4A39_8BA9_8FB39A37DCAD__INCLUDED_)
#define AFX_PHYLO_TREE_RECT_CLADOGRAM_HPP__78D7E7CC_FC75_4A39_8BA9_8FB39A37DCAD__INCLUDED_

/*  $Id: phylo_tree_rect_cladogram.hpp 25300 2012-02-21 20:14:48Z falkrb $
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 * Authors:  Vladimir Tereshkov
 *
 * File Description:
 *
 */

#include <gui/widgets/phylo_tree/phylo_tree_render.hpp>


BEGIN_NCBI_SCOPE

class CGlVboNode;

class NCBI_GUIWIDGETS_PHYLO_TREE_EXPORT CPhyloRectCladogram
    : public IPhyloTreeRenderer
{
protected:
    /// type of corner
    enum  ECorner {
        eTop,
        eMiddle,
        eBottom
    };

    void  x_Calculate(CPhyloTreeNode * node,
                      CBoundaryPoints& boundary_pts,
                      bool compute_boundary = false);
    void  x_DrawTree(CPhyloTreeNode * node);
    void  x_DrawSplineTree(CPhyloTreeNode* node, 
                           vector<CRgbaColor>& edge_colors, 
                           CGlVboNode* point_node);
    void  x_DrawPseudoSplineTree(CPhyloTreeNode* node, 
                                 CGlVboNode* point_node, 
                                 CGlVboNode* edge_node);
    void  x_Render(CGlPane& pane, CPhyloTreeDataSource& ds);
    void  x_RenderVbo(CPhyloTreeDataSource& ds);
    void  x_RenderVboSplines(CPhyloTreeDataSource& ds);
    void  x_RenderVboPseudoSplines(CPhyloTreeDataSource& ds);
    void  x_Layout(CPhyloTreeDataSource& ds);

public:
    CPhyloRectCladogram();
    CPhyloRectCladogram(double w, double h);
    ~CPhyloRectCladogram();
    string  GetDescription(void);

    /// In this layout, LL is almost always occupied with data, so go LR
    virtual bool IsDistanceBarLowerLeft() const { return false; }

    // IPhyloTreeLOD   
    virtual TVPUnit DistanceBetweenNodes(void);

protected:
     virtual TModelUnit x_DistanceBetweenNodes(TModelUnit scaley);
};

END_NCBI_SCOPE

#endif // !defined(AFX_PHYLO_TREE_RECT_CLADOGRAM_HPP__78D7E7CC_FC75_4A39_8BA9_8FB39A37DCAD__INCLUDED_)
