#if !defined(AFX_PHYLO_TREE_SLATED_CLADOGRAM_HPP__78D7E7CC_FC75_4A39_8BA9_8FB39A37DCAD__INCLUDED_)
#define AFX_PHYLO_TREE_SLATED_CLADOGRAM_HPP__78D7E7CC_FC75_4A39_8BA9_8FB39A37DCAD__INCLUDED_

/*  $Id: phylo_tree_slanted_cladogram.hpp 27167 2013-01-03 16:51:27Z falkrb $
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 * Authors:  Vladimir Tereshkov
 *
 * File Description:
 *
 */

#include <gui/widgets/phylo_tree/phylo_tree_render.hpp>


BEGIN_NCBI_SCOPE

class NCBI_GUIWIDGETS_PHYLO_TREE_EXPORT CPhyloSlantedCladogram
    : public IPhyloTreeRenderer
{
protected:
    void  x_Calculate(CPhyloTreeNode * node,
                      CBoundaryPoints& boundary_pts,
                      bool compute_boundary = false);
    void  x_DrawTree(CPhyloTreeNode * node);
    void  x_Render(CGlPane& pane, CPhyloTreeDataSource& ds);
    void  x_Layout(CPhyloTreeDataSource& ds);
    Int4  m_Leafs;
    Int4  m_Width;

    void  x_RenderVbo(CPhyloTreeDataSource& ds);
    void  x_DrawTreeVbo(CPhyloTreeNode * node);
public:
    CPhyloSlantedCladogram();
    CPhyloSlantedCladogram(double w, double h);
    ~CPhyloSlantedCladogram();
    string  GetDescription(void);

    /// Slanted cladagram layout places all leaves on the far right
    virtual bool SupportsDistanceRendering() const { return false; }

    // IPhyloTreeLOD
    TVPUnit DistanceBetweenNodes(void);

protected:
    TModelUnit x_DistanceBetweenNodes(TModelUnit scaley);
};

END_NCBI_SCOPE

#endif // !defined(AFX_PHYLO_TREE_SLATED_CLADOGRAM_HPP__78D7E7CC_FC75_4A39_8BA9_8FB39A37DCAD__INCLUDED_)
