#ifndef GUI_WIDGETS_SEQ_GRAPHIC___SEQGRAPHIC_COLOR_CONF__HPP
#define GUI_WIDGETS_SEQ_GRAPHIC___SEQGRAPHIC_COLOR_CONF__HPP

/*  $Id: color_conf.hpp 15168 2007-10-15 19:11:34Z dicuccio $
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 * Authors:  Robert Smith
 *
 * File Description:
 *   Configuration settings for colors in the Graphic Viewer.
 *
 */

#include <corelib/ncbistd.hpp>
#include <gui/utils/rgba_color.hpp>

BEGIN_NCBI_SCOPE

class CSettingsSet;

class NCBI_GUIWIDGETS_SEQGRAPHIC_EXPORT CSeqGraphicColorConfig
{
public:

    /// Here this include declares enum EDisplayElement
    /// this is intentionally nested inside the class!!!
    #include <gui/widgets/seq_graphic/color_elements.hpp>

    CSeqGraphicColorConfig(const CSettingsSet& settings);

    CRgbaColor GetElementColor(EDisplayElement e) const;

private:

    const CSettingsSet& m_Settings;
};


class NCBI_GUIWIDGETS_SEQGRAPHIC_EXPORT CSeqGraphicColorConfigWrite
        : public CSeqGraphicColorConfig
{
public:
    CSeqGraphicColorConfigWrite(CSettingsSet& settings);

    void SetElementColor(EDisplayElement e, const CRgbaColor& c);
private:
    CSettingsSet& m_Settings;
};



END_NCBI_SCOPE

#endif  /* GUI_WIDGETS_SEQ_GRAPHIC___SEQGRAPHIC_COLOR_CONF__HPP */
