#ifndef GUI_WIDGETS_SEQ_GRAPHIC___SEQGRAPHIC_CONF_MED__HPP
#define GUI_WIDGETS_SEQ_GRAPHIC___SEQGRAPHIC_CONF_MED__HPP

/*  $Id: seqgraphic_conf_med.hpp 14562 2007-05-18 11:48:21Z dicuccio $
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 * Authors:  Robert Smith
 *
 * File Description:
 *  CSeqGraphicConfigMediator
 *
 *  Inherits from CThemeMediator so that we can add view specific stuff like:
 *  telling the CSeqGraphicConfigPanel to provide a detail button for a
 *  particular configuration class or classes owned by CSeqGraphicConfig.
 */

#include <gui/widgets/config/theme_mediator.hpp> // base class

BEGIN_NCBI_SCOPE

class CSeqGraphicConfig;
class CSeqGraphicConfigPanel;


class NCBI_GUIWIDGETS_SEQGRAPHIC_EXPORT CSeqGraphicConfigMediator
    : public CThemeMediator
{
public:
    CSeqGraphicConfigMediator(CSeqGraphicConfig& data,
                              CSeqGraphicConfigPanel& panel);
    virtual ~CSeqGraphicConfigMediator();

    /// What should we title the dialog window?
    virtual string      GetWindowTitle(void) const;

protected:

};


END_NCBI_SCOPE

#endif  /* GUI_WIDGETS_SEQ_GRAPHIC___SEQGRAPHIC_CONF_MED__HPP */
