 #ifndef GUI_WIDGETS_SEQ_GRAPHIC___SEQGRAPHIC_CONF_PANEL__HPP
#define GUI_WIDGETS_SEQ_GRAPHIC___SEQGRAPHIC_CONF_PANEL__HPP

/*  $Id: seqgraphic_conf_panel.hpp 16105 2008-02-22 16:22:52Z lebedev $
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 * Authors:  Robert G. Smith
 *
 * File Description:
 *   define class CSeqGraphicConfigPanel
 *   a CThemeConfigPanel2 with a CSeqGraphicPreview widget in the preview slot.
 */

/// @file theme_config_panel2.hpp
///


// #include <gui/widgets/config/config_panel.hpp>
#include <gui/widgets/config/theme_config_panel2.hpp>
//#include <gui/widgets/config/theme_preview_mediator.hpp>

/** @addtogroup Miscellaneous
 *
 * @{
 */
BEGIN_NCBI_SCOPE

class CSeqGraphicPreview;
class CSeqGraphicConfig;
class CSeqGraphicDataSource;

class NCBI_GUIWIDGETS_SEQGRAPHIC_EXPORT CSeqGraphicConfigPanel : public CThemeConfigPanel2
{
public:
    CSeqGraphicConfigPanel();
    virtual ~CSeqGraphicConfigPanel();

private:
    /// make the popup menus and the preview.
    virtual void            MakeWidgets();
    /// Some widget was just changed, have the preview update itself.
    virtual void            UpdatePreview();

    /// grab and create if necessary the data to display in the preview.
    CSeqGraphicDataSource&  x_GetFakeDataSource();

    /// the configuration object used by the preview widget
     CRef<CSeqGraphicConfig>    m_PreviewConfig;
    /// the mediator used to update the above configuration from this classes widgets.
    CRef<CThemePreviewMediator> m_PreviewMediator;
    // The fake data source to display.
    CRef<CSeqGraphicDataSource> m_PreviewDS;
    /// the widget showing the effect of these settings.
    CSeqGraphicPreview *        m_PreviewWidget;

    /// forbidden
    CSeqGraphicConfigPanel(const CSeqGraphicConfigPanel&);
    CSeqGraphicConfigPanel& operator=(const CSeqGraphicConfigPanel&);

};


END_NCBI_SCOPE


/* @} */

#endif  /* GUI_WIDGETS_SEQ_GRAPHIC___SEQGRAPHIC_CONF_PANEL__HPP */
