#ifndef GUI_WIDGETS_SEQ_GRAPHIC___SEQGRAPHIC_PREVIEW__HPP
#define GUI_WIDGETS_SEQ_GRAPHIC___SEQGRAPHIC_PREVIEW__HPP

/*  $Id: seqgraphic_preview.hpp 25706 2012-04-25 00:21:04Z voronov $
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 * Authors:  Robert G Smith
 *
 * File Description:
 *
 *
 */


#include <corelib/ncbiobj.hpp>

#include <gui/objutils/ui_data_source_notif.hpp>

#include <gui/widgets/gl/gl_widget_base.hpp>


BEGIN_NCBI_SCOPE

class CSeqGraphicDataSource;
class CSeqGraphicConfig;
class CSeqGraphicRenderer;

class NCBI_GUIWIDGETS_SEQGRAPHIC_EXPORT CSeqGraphicPreview : public CGlWidgetPane
{
public:
    CSeqGraphicPreview(int x, int y, int wid, int ht);
    ~CSeqGraphicPreview();

    void SetDataSource(CSeqGraphicDataSource* ds);
    const CSeqGraphicDataSource* GetDataSource(void) const;

    const CSeqGraphicConfig* GetConfig();
    void SetConfig(CRef<CSeqGraphicConfig> config);
    /// the config object just changed. Do what is necessary.
    void UpdateConfig();

protected:
    virtual void draw(void); // NOT called by CGlCanvas::draw()

private:
    CRef<CSeqGraphicDataSource> m_DS;
    CRef<CSeqGraphicRenderer>   m_Renderer;
    CRef<CSeqGraphicConfig>     m_ConfigSettings;

    CSeqGraphicPreview(const CSeqGraphicPreview&);
    CSeqGraphicPreview& operator=(const CSeqGraphicPreview&);
};



END_NCBI_SCOPE

#endif  /* GUI_WIDGETS_SEQ_GRAPHIC___SEQGRAPHIC_PREVIEW__HPP */
