#ifndef GUI_WIDGETS_CONTROLS___TABLE_UTILS__HPP
#define GUI_WIDGETS_CONTROLS___TABLE_UTILS__HPP

/*  $Id: table_utils.hpp 25507 2012-03-28 16:41:17Z katargir $
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 * Authors:  Andrey Yazhuk
 *
 * File Description: Utitlties for working with Table Control
 *
 */

#include <gui/widgets/wx/table_listctrl.hpp>

#include <gui/objutils/registry.hpp>

BEGIN_NCBI_SCOPE


////////////////////////////////////////////////////////////////////////////////
/// CwxTableListCtrl Helper functions

/// Save Table state to CGuiRegistry. Saves column order and column width
void    NCBI_GUIWIDGETS_WX_EXPORT
    SaveTableSettings(const CwxTableListCtrl& table, CGuiRegistry::TReadWriteView view);

/// Restote saved Table state from CGuiRegistry
void NCBI_GUIWIDGETS_WX_EXPORT LoadTableSettings(
    CwxTableListCtrl& table, const CGuiRegistry::TReadView& view, bool byName = false
);


/// Scroll Table so that selection is visible
void    NCBI_GUIWIDGETS_WX_EXPORT
    MakeSelectedVisible(CwxTableListCtrl& table);

void    NCBI_GUIWIDGETS_WX_EXPORT
ExportTableControlToCSV( CwxTableListCtrl& table );

bool    NCBI_GUIWIDGETS_WX_EXPORT
    ShowColumnDialog(CwxTableListCtrl& table, const string& title);

END_NCBI_SCOPE

#endif // GUI_WIDGETS_CONTROLS___TABLE_UTILS__HPP
