/*  $Id: feat_show.cpp 14565 2007-05-18 12:32:01Z dicuccio $
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 * Authors:  Robert Smith
 *
 */

/// @file feat_show.cpp
///



#include <ncbi_pch.hpp>
#include <gui/config/feat_show.hpp>
#include <gui/config/settings_set.hpp>
#include <gui/objutils/registry.hpp>

BEGIN_NCBI_SCOPE



// definitions for CFeatConfigShow

/// use this cstr when declaring a CFeatConfigShow object.
CFeatConfigShow::CFeatConfigShow(CSettingsSet& settings)
    : m_Settings(settings)
{
}


bool CFeatConfigShow::GetShow(int subtype) const
{
    return m_Settings.GetBool(m_Settings.GetFeatReadKey(subtype, kEmptyStr, "show") );
}


void CFeatConfigShow::SetShow(int subtype, bool show)
{
    m_Settings.Set(CSettingsSet::GetFeatWriteKey(subtype, kEmptyStr) +
                   CSettingsSet::kDefaultDelim + "show",
                   show);
}


END_NCBI_SCOPE
