/*  $Id: cmd_del_seq_feat.cpp 27297 2013-01-24 13:32:52Z bollin $
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data,  the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties,  express or implied,  including
 *  warranties of performance,  merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 * Authors:  Roman Katargin
 */


#include <ncbi_pch.hpp>
#include <gui/objutils/cmd_del_seq_feat.hpp>

BEGIN_NCBI_SCOPE
USING_SCOPE(objects);

void CCmdDelSeq_feat::Execute()
{
    if (!m_Saved_feat) {
        m_Saved_feat = m_Orig_feat.GetOriginalSeq_feat();
        CSeq_feat_EditHandle feh(m_Orig_feat);
        feh.Remove();
    }
}

void CCmdDelSeq_feat::Unexecute()
{
    if (m_Saved_feat) {
        CSeq_feat_EditHandle feh(m_Orig_feat);
        feh.Replace(*m_Saved_feat);
        m_Saved_feat.Reset();
    }
}

string CCmdDelSeq_feat::GetLabel()
{
    return "Delete feature";
}


END_NCBI_SCOPE
