/*  $Id: glviewport.cpp 14565 2007-05-18 12:32:01Z dicuccio $
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 * Authors:  Mike DiCuccio
 *
 * File Description:
 *
 */

#include <ncbi_pch.hpp>
#include <gui/opengl/glviewport.hpp>

BEGIN_NCBI_SCOPE


CGlViewport::CGlViewport()
    : m_X(0),
      m_Y(0),
      m_Width(100),
      m_Height(100)
{
}


CGlViewport::CGlViewport(GLint x, GLint y, GLint width, GLint height)
    : m_X(x),
      m_Y(y),
      m_Width(width),
      m_Height(height)
{
}


void CGlViewport::MakeCurrent(bool save_viewport)
{
    if (save_viewport) {
        glPushAttrib(GL_VIEWPORT_BIT);
    }
    glViewport(m_X, m_Y, m_Width, m_Height);
}


void CGlViewport::ReleaseCurrent(bool restore_viewport)
{
    if (restore_viewport) {
        glPopAttrib();
    }
}


END_NCBI_SCOPE
