#ifndef PKG_ALIGNMENT___PHY_LOAD_PAGE__HPP
#define PKG_ALIGNMENT___PHY_LOAD_PAGE__HPP

/*  $Id: phy_load_page.hpp 18606 2009-01-08 21:31:44Z tereshko $
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data,  the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties,  express or implied,  including
 *  warranties of performance,  merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 * Authors:  Vladimir Tereshkov
 */

#include <corelib/ncbistd.hpp>

/*!
 * Includes
 */

#include <wx/panel.h>

#include <gui/packages/pkg_alignment/phy_load_params.hpp>

/*!
 * Forward declarations
 */

////@begin forward declarations
////@end forward declarations

/*!
 * Control identifiers
 */

////@begin control identifiers
#define SYMBOL_CPhyLoadPage_STYLE wxTAB_TRAVERSAL
#define SYMBOL_CPhyLoadPage_TITLE _("AGP Load Params Panel")
#define SYMBOL_CPhyLoadPage_IDNAME ID_CPhyLoadPage
#define SYMBOL_CPhyLoadPage_SIZE wxSize(400, 300)
#define SYMBOL_CPhyLoadPage_POSITION wxDefaultPosition
////@end control identifiers

BEGIN_NCBI_SCOPE

/*!
 * CPhyLoadPage class declaration
 */

class CPhyLoadPage: public wxPanel
{
    DECLARE_DYNAMIC_CLASS( CPhyLoadPage )
    DECLARE_EVENT_TABLE()

public:
    /// Constructors
    CPhyLoadPage();
    CPhyLoadPage( wxWindow* parent, wxWindowID id = SYMBOL_CPhyLoadPage_IDNAME, const wxPoint& pos = SYMBOL_CPhyLoadPage_POSITION, const wxSize& size = SYMBOL_CPhyLoadPage_SIZE, long style = SYMBOL_CPhyLoadPage_STYLE );

    /// Creation
    bool Create( wxWindow* parent, wxWindowID id = SYMBOL_CPhyLoadPage_IDNAME, const wxPoint& pos = SYMBOL_CPhyLoadPage_POSITION, const wxSize& size = SYMBOL_CPhyLoadPage_SIZE, long style = SYMBOL_CPhyLoadPage_STYLE );

    /// Destructor
    ~CPhyLoadPage();

    /// Initialises member variables
    void Init();

    /// Creates the controls and sizers
    void CreateControls();

    /// Transfer data to the window
    virtual bool TransferDataToWindow();

    /// Transfer data from the window
    virtual bool TransferDataFromWindow();

////@begin CPhyLoadPage event handler declarations

////@end CPhyLoadPage event handler declarations

////@begin CPhyLoadPage member function declarations

    /// Data access
    CPhyLoadParams& GetData() { return m_data; }
    const CPhyLoadParams& GetData() const { return m_data; }
    void SetData(const CPhyLoadParams& data) { m_data = data; }

    /// Retrieves bitmap resources
    wxBitmap GetBitmapResource( const wxString& name );

    /// Retrieves icon resources
    wxIcon GetIconResource( const wxString& name );
////@end CPhyLoadPage member function declarations

    /// Should we show tooltips?
    static bool ShowToolTips();

////@begin CPhyLoadPage member variables
    /// The data edited by this window
    CPhyLoadParams m_data;
    /// Control identifiers
    enum {
        ID_CPhyLoadPage = 10041,
        ID_RADIOBOX2 = 10042,
        ID_CHECKBOX16 = 10043,
        ID_TEXTCTRL6 = 10044,
        ID_BUTTON3 = 10045
    };
////@end CPhyLoadPage member variables
};

END_NCBI_SCOPE

#endif // PKG_ALIGNMENT___PHY_LOAD_PAGE__HPP
