/*  $Id: bam_coverage_graph_panel.cpp 26288 2012-08-20 16:13:39Z katargir $
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data,  the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties,  express or implied,  including
 *  warranties of performance,  merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 * Authors:  Liangshou Wu
 */


// Generated by DialogBlocks (unregistered), 02/03/2011 09:12:09

#include <ncbi_pch.hpp>
#include "bam_coverage_graph_panel.hpp"
#include <gui/widgets/wx/wx_utils.hpp>
#include <corelib/ncbifile.hpp>
#include <wx/dirdlg.h>
#include <wx/filename.h>
#include <wx/checkbox.h>
#include <wx/radiobut.h>
#include <wx/sizer.h>
#include <wx/stattext.h>
#include <wx/statbox.h>
#include <wx/button.h>
#include <wx/msgdlg.h>
#include <wx/textctrl.h>
#include <wx/filedlg.h>


////@begin XPM images
////@end XPM images

BEGIN_NCBI_SCOPE

/*!
 * CBamCoverageGraphPanel type definition
 */

IMPLEMENT_DYNAMIC_CLASS( CBamCoverageGraphPanel, wxPanel )


/*!
 * CBamCoverageGraphPanel event table definition
 */

BEGIN_EVENT_TABLE( CBamCoverageGraphPanel, wxPanel )

////@begin CBamCoverageGraphPanel event table entries
    EVT_RADIOBUTTON( ID_AUTOGEN, CBamCoverageGraphPanel::OnAutogenSelected )

    EVT_CHECKBOX( ID_SAVETO, CBamCoverageGraphPanel::OnSavetoClick )

    EVT_BUTTON( ID_CHANGEBUTTON, CBamCoverageGraphPanel::OnChangebuttonClick )

    EVT_RADIOBUTTON( ID_MANUALSELECT, CBamCoverageGraphPanel::OnManualselectSelected )

    EVT_BUTTON( ID_BROWSEBUTTON, CBamCoverageGraphPanel::OnBrowsebuttonClick )

////@end CBamCoverageGraphPanel event table entries

END_EVENT_TABLE()


/*!
 * CBamCoverageGraphPanel constructors
 */

CBamCoverageGraphPanel::CBamCoverageGraphPanel()
{
    Init();
}

CBamCoverageGraphPanel::CBamCoverageGraphPanel( wxWindow* parent, wxWindowID id, const wxString& caption, const wxPoint& pos, const wxSize& size, long style )
{
    Init();
    Create(parent, id, caption, pos, size, style);
}


/*!
 * CBamCoverageGraphPanel creator
 */

bool CBamCoverageGraphPanel::Create( wxWindow* parent, wxWindowID id, const wxString& caption, const wxPoint& pos, const wxSize& size, long style )
{
////@begin CBamCoverageGraphPanel creation
    wxPanel::Create( parent, id, pos, size, style );

    CreateControls();
    if (GetSizer())
    {
        GetSizer()->SetSizeHints(this);
    }
    Centre();
////@end CBamCoverageGraphPanel creation

    return true;
}


/*!
 * CBamCoverageGraphPanel destructor
 */

CBamCoverageGraphPanel::~CBamCoverageGraphPanel()
{
////@begin CBamCoverageGraphPanel destruction
////@end CBamCoverageGraphPanel destruction
}


/*!
 * Member initialisation
 */

void CBamCoverageGraphPanel::Init()
{
////@begin CBamCoverageGraphPanel member initialisation
    m_AutoGenRadio = NULL;
    m_AutoGenBox = NULL;
    m_BinSize = NULL;
    m_SaveTo = NULL;
    m_SaveToBox = NULL;
    m_SaveLocationBox = NULL;
    m_ManualSelectRadio = NULL;
    m_ManualSelectBox = NULL;
    m_GraphFileBox = NULL;
////@end CBamCoverageGraphPanel member initialisation
}


/*!
 * Control creation for CBamCoverageGraphPanel
 */

void CBamCoverageGraphPanel::CreateControls()
{    
////@begin CBamCoverageGraphPanel content construction
    CBamCoverageGraphPanel* itemPanel1 = this;

    wxStaticBox* itemStaticBoxSizer2Static = new wxStaticBox(itemPanel1, wxID_ANY, _("Coverage graph options"));
    wxStaticBoxSizer* itemStaticBoxSizer2 = new wxStaticBoxSizer(itemStaticBoxSizer2Static, wxVERTICAL);
    itemPanel1->SetSizer(itemStaticBoxSizer2);

    wxBoxSizer* itemBoxSizer3 = new wxBoxSizer(wxVERTICAL);
    itemStaticBoxSizer2->Add(itemBoxSizer3, 0, wxGROW|wxALL, 5);

    m_AutoGenRadio = new wxRadioButton( itemPanel1, ID_AUTOGEN, _("Generate a graph automatically"), wxDefaultPosition, wxDefaultSize, wxRB_GROUP );
    m_AutoGenRadio->SetValue(true);
    itemBoxSizer3->Add(m_AutoGenRadio, 0, wxALIGN_LEFT|wxALL, 5);

    m_AutoGenBox = new wxPanel( itemPanel1, ID_PANEL5, wxDefaultPosition, wxDefaultSize, wxTAB_TRAVERSAL );
    itemBoxSizer3->Add(m_AutoGenBox, 0, wxGROW|wxLEFT|wxRIGHT|wxBOTTOM, 5);

    wxBoxSizer* itemBoxSizer6 = new wxBoxSizer(wxVERTICAL);
    m_AutoGenBox->SetSizer(itemBoxSizer6);

    wxBoxSizer* itemBoxSizer7 = new wxBoxSizer(wxHORIZONTAL);
    itemBoxSizer6->Add(itemBoxSizer7, 0, wxALIGN_LEFT|wxRIGHT, 5);

    itemBoxSizer7->Add(10, 5, 0, wxALIGN_CENTER_VERTICAL|wxLEFT|wxRIGHT|wxBOTTOM, 5);

    wxStaticText* itemStaticText9 = new wxStaticText( m_AutoGenBox, wxID_STATIC, _("Graph bin size (bases):"), wxDefaultPosition, wxDefaultSize, 0 );
    itemBoxSizer7->Add(itemStaticText9, 0, wxALIGN_CENTER_VERTICAL|wxLEFT|wxRIGHT|wxBOTTOM, 5);

    m_BinSize = new wxSpinCtrl( m_AutoGenBox, ID_SPINCTRL, _("1000"), wxDefaultPosition, wxSize(80, -1), wxSP_ARROW_KEYS, 1, 1000000, 1000 );
    itemBoxSizer7->Add(m_BinSize, 0, wxALIGN_CENTER_VERTICAL|wxLEFT|wxRIGHT, 5);

    itemBoxSizer7->Add(20, 5, 0, wxALIGN_CENTER_VERTICAL|wxLEFT|wxRIGHT|wxBOTTOM, 5);

    m_SaveTo = new wxCheckBox( m_AutoGenBox, ID_SAVETO, _("Save Graph"), wxDefaultPosition, wxDefaultSize, 0 );
    m_SaveTo->SetValue(false);
    itemBoxSizer7->Add(m_SaveTo, 0, wxALIGN_CENTER_VERTICAL|wxLEFT|wxRIGHT|wxBOTTOM, 5);

    m_SaveToBox = new wxPanel( m_AutoGenBox, ID_PANEL6, wxDefaultPosition, wxDefaultSize, wxTAB_TRAVERSAL );
    itemBoxSizer6->Add(m_SaveToBox, 0, wxGROW|wxBOTTOM, 5);

    wxBoxSizer* itemBoxSizer14 = new wxBoxSizer(wxHORIZONTAL);
    m_SaveToBox->SetSizer(itemBoxSizer14);

    itemBoxSizer14->Add(10, 5, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5);

    wxStaticText* itemStaticText16 = new wxStaticText( m_SaveToBox, wxID_STATIC, _("Save as"), wxDefaultPosition, wxDefaultSize, 0 );
    itemBoxSizer14->Add(itemStaticText16, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5);

    m_SaveLocationBox = new wxTextCtrl( m_SaveToBox, ID_TEXTCTRL, wxEmptyString, wxDefaultPosition, wxSize(185, -1), 0 );
    itemBoxSizer14->Add(m_SaveLocationBox, 1, wxALIGN_CENTER_VERTICAL|wxRIGHT, 5);

    wxButton* itemButton18 = new wxButton( m_SaveToBox, ID_CHANGEBUTTON, _("Change"), wxDefaultPosition, wxSize(70, -1), 0 );
    itemBoxSizer14->Add(itemButton18, 0, wxALIGN_CENTER_VERTICAL|wxLEFT|wxRIGHT, 5);

    m_ManualSelectRadio = new wxRadioButton( itemPanel1, ID_MANUALSELECT, _("Use existing graph files"), wxDefaultPosition, wxDefaultSize, 0 );
    m_ManualSelectRadio->SetValue(false);
    itemBoxSizer3->Add(m_ManualSelectRadio, 0, wxALIGN_LEFT|wxALL, 5);

    m_ManualSelectBox = new wxPanel( itemPanel1, ID_PANEL4, wxDefaultPosition, wxDefaultSize, wxTAB_TRAVERSAL );
    itemBoxSizer3->Add(m_ManualSelectBox, 0, wxGROW|wxLEFT|wxRIGHT, 5);

    wxBoxSizer* itemBoxSizer21 = new wxBoxSizer(wxHORIZONTAL);
    m_ManualSelectBox->SetSizer(itemBoxSizer21);

    itemBoxSizer21->Add(10, 5, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5);

    wxStaticText* itemStaticText23 = new wxStaticText( m_ManualSelectBox, wxID_STATIC, _("File:"), wxDefaultPosition, wxDefaultSize, 0 );
    itemBoxSizer21->Add(itemStaticText23, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5);

    m_GraphFileBox = new wxTextCtrl( m_ManualSelectBox, ID_TEXTCTRL8, wxEmptyString, wxDefaultPosition, wxSize(200, -1), 0 );
    itemBoxSizer21->Add(m_GraphFileBox, 1, wxALIGN_CENTER_VERTICAL|wxALL, 5);

    wxButton* itemButton25 = new wxButton( m_ManualSelectBox, ID_BROWSEBUTTON, _("Browse"), wxDefaultPosition, wxSize(70, -1), 0 );
    itemBoxSizer21->Add(itemButton25, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5);

////@end CBamCoverageGraphPanel content construction
    m_ManualSelectBox->Enable(false);
    m_SaveToBox->Hide();
}


void CBamCoverageGraphPanel::SetBamFiles(const set<string>& bam_files)
{
    if (bam_files.empty()) return;

    m_BamFiles = bam_files;
    wxString def_graph_file = ToWxString(*bam_files.begin()) + wxT(".graph");
    wxString def_path;
    wxFileName::SplitPath(def_graph_file, &def_path, NULL, NULL);
    bool single_input = m_BamFiles.size() == 1;

    if (m_GraphFileBox) {
        if (single_input) {
            m_GraphFileBox->SetValue(def_graph_file);
        } else {
            m_GraphFileBox->SetValue(def_path);
        }
    }
    if (m_SaveLocationBox) {
        if (single_input) {
            m_SaveLocationBox->SetValue(def_graph_file);
        } else {
            m_SaveLocationBox->SetValue(def_path);
        }
    }

    bool has_graph_files = true;
    ITERATE (set<string>, iter, m_BamFiles) {
        string graph_file = *iter + ".graph";
        if ( !CFile(graph_file).Exists() ) {
            has_graph_files = false;
            break;
        }
    }

    if (has_graph_files) {
        m_ManualSelectRadio->SetValue(true);
        m_ManualSelectBox->Enable(true);
        m_AutoGenRadio->SetValue(false);
        m_AutoGenBox->Enable(false);
    }
}


string CBamCoverageGraphPanel::GetGraphFile(const string& bam_file) const
{
    return ToStdString(GetGraphFile_wx(bam_file));
}


wxString CBamCoverageGraphPanel::GetGraphFile_wx(const string& bam_file) const
{
    bool single_input = m_BamFiles.size() == 1;
    if (m_ManualSelectRadio->GetValue()) {
        if (single_input) {
            return m_GraphFileBox->GetValue();
        } else {
            string base, ext;
            CDirEntry::SplitPath(bam_file, NULL, &base, &ext);
            wxString graph_file = m_GraphFileBox->GetValue();
            graph_file += wxFileName::GetPathSeparator();
            graph_file += ToWxString(base + ext + ".graph");
            return graph_file;
        }
    } else if (m_SaveTo->GetValue()) {
        if (single_input) {
            return m_SaveLocationBox->GetValue();
        } else {
            string base, ext;
            CDirEntry::SplitPath(bam_file, NULL, &base, &ext);
            wxString graph_file = m_SaveLocationBox->GetValue();
            graph_file += wxFileName::GetPathSeparator();
            graph_file += ToWxString(base + ext + ".graph");
            return graph_file;
        }
    }
    return wxString(wxT(""));
}


int CBamCoverageGraphPanel::GetGraphBinSize() const
{
    return m_BinSize->GetValue();
}


#define GRAPH_FILE_ERR "BAM Coverage Graph - error in input"

bool CBamCoverageGraphPanel::IsInputValid()
{
    bool valid = true;
    set<string>::const_iterator iter = m_BamFiles.begin();
    bool single_input = m_BamFiles.size() == 1;
    bool remove_existing_files = false;
    while (valid  &&  iter != m_BamFiles.end()) {
        wxString graph_file = GetGraphFile_wx(*iter);
        if (m_ManualSelectRadio->GetValue()) {
            if ( !wxFileExists(graph_file) )  {
                wxString err_msg;
                if (single_input) {
                    err_msg = wxT("The selected file doesn't exist! File: ");
                    err_msg += graph_file;
                } else {
                    err_msg = wxT("Not all Bam files have a graph file under the selected folder: ");
                    err_msg += m_GraphFileBox->GetValue();
                }
                wxMessageBox(err_msg, wxT(GRAPH_FILE_ERR),
                    wxOK | wxICON_ERROR, this);
                valid = false;
            }
        } else if ( !graph_file.IsEmpty() ) {
            // make sure the folder exists and writable;
            wxString path;
            wxFileName::SplitPath(graph_file, &path, NULL, NULL);
            if ( !wxDirExists(path) ) {
                wxString err_msg = wxT("The input directory doesn't exist! File: ");
                err_msg += path;
                wxMessageBox(err_msg, wxT(GRAPH_FILE_ERR),
                    wxOK | wxICON_ERROR, this);
                valid = false;
            } else if ( !wxFileName::IsDirWritable(path) ) {
                wxString err_msg = wxT("No write permission to the input directory: ");
                err_msg += path;
                wxMessageBox(err_msg, wxT(GRAPH_FILE_ERR),
                    wxOK | wxICON_ERROR, this);
                valid = false;
            } else if (wxFileExists(graph_file)) {
                if ( !remove_existing_files ) {
                    // make sure user really wants to overwrite an existing file
                    wxString err_msg;
                    if (single_input) {
                        err_msg = wxT("The input file already exists. Really want to overwrite it?  File: ");
                        err_msg += graph_file;
                    } else {
                        err_msg = wxT("Graph files for some Bam files already exist under the selected folder: ");
                        err_msg += path;
                        err_msg += wxT(". Really want to overwrite them?");
                    }
                    int res = wxMessageBox(err_msg, wxT(GRAPH_FILE_ERR),
                        wxYES_NO | wxICON_EXCLAMATION, this);
                    valid = (res == wxYES);
                    remove_existing_files = valid;
                }
                if (remove_existing_files) {
                    // delete the file
                    wxRemoveFile(graph_file);
                }
            }
        }
        if (!valid) {
            break;
        }
        ++iter;
    }

    return valid;
}



/*!
 * Should we show tooltips?
 */

bool CBamCoverageGraphPanel::ShowToolTips()
{
    return true;
}

/*!
 * Get bitmap resources
 */

wxBitmap CBamCoverageGraphPanel::GetBitmapResource( const wxString& name )
{
    // Bitmap retrieval
////@begin CBamCoverageGraphPanel bitmap retrieval
    wxUnusedVar(name);
    return wxNullBitmap;
////@end CBamCoverageGraphPanel bitmap retrieval
}

/*!
 * Get icon resources
 */

wxIcon CBamCoverageGraphPanel::GetIconResource( const wxString& name )
{
    // Icon retrieval
////@begin CBamCoverageGraphPanel icon retrieval
    wxUnusedVar(name);
    return wxNullIcon;
////@end CBamCoverageGraphPanel icon retrieval
}


/*!
 * wxEVT_COMMAND_BUTTON_CLICKED event handler for ID_BROWSEBUTTON
 */

void CBamCoverageGraphPanel::OnBrowsebuttonClick( wxCommandEvent& event )
{
    wxString old_path = m_GraphFileBox->GetValue();
    wxString def_path;
    wxFileName::SplitPath(old_path, &def_path, NULL, NULL);

    
    if (m_BamFiles.size() == 1) {
        wxFileDialog dlg(this, wxT("Select a BAM coverage graph file"), def_path, wxT(""),
            wxT("Graph files (") wxALL_FILES_PATTERN wxT(")|") wxALL_FILES_PATTERN,
            wxFD_OPEN);

        if (dlg.ShowModal() == wxID_OK) {
            m_GraphFileBox->SetValue(dlg.GetPath());
        }
    } else {
        wxDirDialog dlg(this, wxT("Select the folder all graph files reside"),
            def_path, wxDD_DIR_MUST_EXIST);
        if (dlg.ShowModal() == wxID_OK) {
            m_GraphFileBox->SetValue(dlg.GetPath());
        }
    }
}


/*!
 * wxEVT_COMMAND_BUTTON_CLICKED event handler for ID_CHANGEBUTTON
 */

void CBamCoverageGraphPanel::OnChangebuttonClick( wxCommandEvent& event )
{
    wxString old_path = m_SaveLocationBox->GetValue();
    wxString def_path;
    wxFileName::SplitPath(old_path, &def_path, NULL, NULL);

    if (m_BamFiles.size() == 1) {
        wxFileDialog dlg(this,
            wxT("Select a folder and input a file name to save coverage graph"),
            def_path);
        if (dlg.ShowModal() == wxID_OK) {
            m_SaveLocationBox->SetValue(dlg.GetPath());
        }
    } else {
        wxDirDialog dlg(this, wxT("Choose an existing folder to save graph files"),
            def_path, wxDD_DIR_MUST_EXIST);
        if (dlg.ShowModal() == wxID_OK) {
            m_SaveLocationBox->SetValue(dlg.GetPath());
        }
    }

}

/*!
 * wxEVT_COMMAND_RADIOBUTTON_SELECTED event handler for ID_MANUALSELECT
 */

void CBamCoverageGraphPanel::OnManualselectSelected( wxCommandEvent& event )
{
    m_AutoGenBox->Enable(false);
    m_ManualSelectBox->Enable(true);
}


/*!
 * wxEVT_COMMAND_RADIOBUTTON_SELECTED event handler for ID_AUTOGEN
 */

void CBamCoverageGraphPanel::OnAutogenSelected( wxCommandEvent& event )
{
    m_ManualSelectBox->Enable(false);
    m_AutoGenBox->Enable(true);
}


/*!
 * wxEVT_COMMAND_CHECKBOX_CLICKED event handler for ID_SAVETO
 */

void CBamCoverageGraphPanel::OnSavetoClick( wxCommandEvent& event )
{
    if (m_SaveTo->GetValue()) {
        m_SaveToBox->Show(true);
    } else {
        m_SaveToBox->Hide();
    }
    Layout();
}


END_NCBI_SCOPE


