/*  $Id: bam_coverage_graph_panel.hpp 24676 2011-11-03 16:12:24Z wuliangs $
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data,  the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties,  express or implied,  including
 *  warranties of performance,  merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 * Authors:  Liangshou Wu
 */
// Generated by DialogBlocks (unregistered), 02/03/2011 09:12:09

#ifndef _BAM_COVERAGE_GRAPH_PANEL_H_
#define _BAM_COVERAGE_GRAPH_PANEL_H_

#include <corelib/ncbistd.hpp>
#include <corelib/ncbiobj.hpp>
#include <wx/panel.h>
#include <set>

/*!
 * Includes
 */

////@begin includes
#include "wx/spinctrl.h"
////@end includes

/*!
 * Forward declarations
 */

////@begin forward declarations
class wxSpinCtrl;
////@end forward declarations

class wxRadioButton;
class wxCheckBox;
class wxTextCtrl;

/*!
 * Control identifiers
 */

////@begin control identifiers
#define SYMBOL_CBAMCOVERAGEGRAPHPANEL_STYLE wxTAB_TRAVERSAL
#define SYMBOL_CBAMCOVERAGEGRAPHPANEL_TITLE _("Bam Coverage Graph")
#define SYMBOL_CBAMCOVERAGEGRAPHPANEL_IDNAME ID_CBAMCOVERAGEGRAPHPANEL
#define SYMBOL_CBAMCOVERAGEGRAPHPANEL_SIZE wxSize(400, 300)
#define SYMBOL_CBAMCOVERAGEGRAPHPANEL_POSITION wxDefaultPosition
////@end control identifiers


BEGIN_NCBI_SCOPE

/*!
 * CBamCoverageGraphPanel class declaration
 */

class CBamCoverageGraphPanel: public wxPanel
{    
    DECLARE_DYNAMIC_CLASS( CBamCoverageGraphPanel )
    DECLARE_EVENT_TABLE()

public:
    /// Constructors
    CBamCoverageGraphPanel();
    CBamCoverageGraphPanel( wxWindow* parent, wxWindowID id = SYMBOL_CBAMCOVERAGEGRAPHPANEL_IDNAME, const wxString& caption = SYMBOL_CBAMCOVERAGEGRAPHPANEL_TITLE, const wxPoint& pos = SYMBOL_CBAMCOVERAGEGRAPHPANEL_POSITION, const wxSize& size = SYMBOL_CBAMCOVERAGEGRAPHPANEL_SIZE, long style = SYMBOL_CBAMCOVERAGEGRAPHPANEL_STYLE );

    /// Creation
    bool Create( wxWindow* parent, wxWindowID id = SYMBOL_CBAMCOVERAGEGRAPHPANEL_IDNAME, const wxString& caption = SYMBOL_CBAMCOVERAGEGRAPHPANEL_TITLE, const wxPoint& pos = SYMBOL_CBAMCOVERAGEGRAPHPANEL_POSITION, const wxSize& size = SYMBOL_CBAMCOVERAGEGRAPHPANEL_SIZE, long style = SYMBOL_CBAMCOVERAGEGRAPHPANEL_STYLE );

    /// Destructor
    ~CBamCoverageGraphPanel();

    /// Initialises member variables
    void Init();

    /// Creates the controls and sizers
    void CreateControls();

    void SetBamFiles(const set<string>& bam_files);
    string GetGraphFile(const string& bam_file) const;
    wxString GetGraphFile_wx(const string& bam_file) const;
    int  GetGraphBinSize() const;
    bool IsInputValid();

////@begin CBamCoverageGraphPanel event handler declarations

    /// wxEVT_COMMAND_RADIOBUTTON_SELECTED event handler for ID_AUTOGEN
    void OnAutogenSelected( wxCommandEvent& event );

    /// wxEVT_COMMAND_CHECKBOX_CLICKED event handler for ID_SAVETO
    void OnSavetoClick( wxCommandEvent& event );

    /// wxEVT_COMMAND_BUTTON_CLICKED event handler for ID_CHANGEBUTTON
    void OnChangebuttonClick( wxCommandEvent& event );

    /// wxEVT_COMMAND_RADIOBUTTON_SELECTED event handler for ID_MANUALSELECT
    void OnManualselectSelected( wxCommandEvent& event );

    /// wxEVT_COMMAND_BUTTON_CLICKED event handler for ID_BROWSEBUTTON
    void OnBrowsebuttonClick( wxCommandEvent& event );

////@end CBamCoverageGraphPanel event handler declarations

////@begin CBamCoverageGraphPanel member function declarations

    /// Retrieves bitmap resources
    wxBitmap GetBitmapResource( const wxString& name );

    /// Retrieves icon resources
    wxIcon GetIconResource( const wxString& name );
////@end CBamCoverageGraphPanel member function declarations

    /// Should we show tooltips?
    static bool ShowToolTips();

////@begin CBamCoverageGraphPanel member variables
    wxRadioButton* m_AutoGenRadio;
    wxPanel* m_AutoGenBox;
    wxSpinCtrl* m_BinSize;
    wxCheckBox* m_SaveTo;
    wxPanel* m_SaveToBox;
    wxTextCtrl* m_SaveLocationBox;
    wxRadioButton* m_ManualSelectRadio;
    wxPanel* m_ManualSelectBox;
    wxTextCtrl* m_GraphFileBox;
    /// Control identifiers
    enum {
        ID_CBAMCOVERAGEGRAPHPANEL = 10074,
        ID_AUTOGEN = 10075,
        ID_PANEL5 = 10080,
        ID_SPINCTRL = 10086,
        ID_SAVETO = 10081,
        ID_PANEL6 = 10082,
        ID_TEXTCTRL = 10000,
        ID_CHANGEBUTTON = 10001,
        ID_MANUALSELECT = 10076,
        ID_PANEL4 = 10079,
        ID_TEXTCTRL8 = 10077,
        ID_BROWSEBUTTON = 10078
    };
////@end CBamCoverageGraphPanel member variables

    set<string>  m_BamFiles;
};


END_NCBI_SCOPE

#endif
    // _BAM_COVERAGE_GRAPH_PANEL_H_
