#ifndef PKG_SEQUENCE_EDIT___BTNS_EVENT__HPP
#define PKG_SEQUENCE_EDIT___BTNS_EVENT__HPP

/*  $Id: btns_event.hpp 26496 2012-09-26 12:52:36Z bollin $
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 * Authors:  Roman Katargin
 *
 * File Description:
 *
 */

#include <corelib/ncbiobj.hpp>

#include <gui/utils/event.hpp>

#include <objects/submit/Seq_submit.hpp>

BEGIN_NCBI_SCOPE

class CEditingBtnsEvent : public CEvent
{
public:
    typedef CEventAttachmentFor<CRef<objects::CSeq_submit> > TSeq_submitAttachment;

    enum EEventType {
        eWrapSeq_submit,
        eUnknownEvent = -1
    };

    /// create an event for a given event ID, with event class Unknown
    CEditingBtnsEvent(TEventID eid)
        : CEvent(eid)
    {
    }

    /// create an event for a specific event class and ID
    CEditingBtnsEvent(TEventClass ecl, TEventID eid)
        : CEvent(ecl, eid)
    {
    }

};

END_NCBI_SCOPE

#endif  // PKG_SEQUENCE_EDIT___BTNS_EVENT__HPP
