/*  $Id: ihelp_handler.cpp 14984 2007-09-14 17:04:27Z tereshko $
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 * Authors:  Vladimir Tereshkov
 *
 * File Description:
 *
 */

#include <ncbi_pch.hpp>
#include <corelib/ncbistd.hpp>
#include <corelib/ncbiapp.hpp>
#include <gui/utils/ihelp_handler.hpp>
#include <gui/utils/app_popup.hpp>

BEGIN_NCBI_SCOPE

string IHelpHandler::sm_BaseUrl;

IHelpHandler::IHelpHandler()
{
}


IHelpHandler::~IHelpHandler()
{
}


void IHelpHandler::SetBaseUrl(const string& s)
{
    sm_BaseUrl = s;
}


string IHelpHandler::x_GetHelpUrl(const string& token)
{
    string help_url = sm_BaseUrl;
    if ( !token.empty() ) {
        help_url += "?topic=";
        help_url += token;
    }
    return help_url;
}


// opening popup
void IHelpHandler::OnHelpContext(void)
{
    OnHelpContext(GetHelpToken());
}


void IHelpHandler::OnHelpContext(const string& token)
{
    string url = x_GetHelpUrl(token);
    CAppPopup::PopupURL(url);
}


END_NCBI_SCOPE
