#ifndef GUI_WIDGETS_SEQ_GRAPHIC___CONFIG__HPP
#define GUI_WIDGETS_SEQ_GRAPHIC___CONFIG__HPP

/*  $Id: test_settings.hpp 15169 2007-10-15 19:55:39Z yazhuk $
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 * Authors:  Robert Smith
 *
 * File Description:
 *   Preferences for the Graphic Sequence view widget
 *   Independent from FLTK.
 *
 */

#include <gui/config/settings_set.hpp>

#include <gui/gui.hpp>
#include <gui/opengl.h>
#include <gui/opengl/glcolortable.hpp>

#include <gui/objutils/utils.hpp>
#include <gui/objutils/feature.hpp>

#include <objmgr/util/feature.hpp>


BEGIN_NCBI_SCOPE

class CRgbaColor;
class CSeqGraphicView;

class CTestSettings : public CSettingsSet
{
public:
    CTestSettings(CRef<objects::CPluginConfigCache> config_cache);

    bool LoadCurrentSettings(ELoadValueSource src);
    bool SaveCurrentSettings(void);

    CRgbaColor m_SelectionColor;   // Color for selection
    bool m_ShowFeatures;    // option to show all features
    string  m_Name;

};

END_NCBI_SCOPE

#endif  /* GUI_WIDGETS_SEQ_GRAPHIC___CONFIG__HPP */
