/*  $Id: test_theme_set.cpp 14565 2007-05-18 12:32:01Z dicuccio $
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 * Authors:  Robert Smith
 *
 * File Description:
 *   Preferences for the Graphic Sequence view widget
 *   Independent from FLTK.
 *
 */

#include <ncbi_pch.hpp>
#include "test_theme_set.hpp"

#include <gui/config/feat_color.hpp>
#include <gui/config/feat_show.hpp>

BEGIN_NCBI_SCOPE

CTestThemeSettings::CTestThemeSettings(CRef<objects::CPluginConfigCache> config_cache)
    : CThemeSet(config_cache, "test theme set" ),
      m_Colors(new CFeatConfigColor(config_cache, "Colors")),
      m_PaneContent(new CFeatConfigShow(config_cache, "Content"))
{
    AddSettingsSet(*m_Colors);
    AddSettingsSet(*m_PaneContent);

    LoadCurrentSettings(eLoad_Current);
}


END_NCBI_SCOPE
