/*  $Id: remarksandserialnumber_panel.cpp 25028 2012-01-12 17:26:13Z katargir $
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data,  the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties,  express or implied,  including
 *  warranties of performance,  merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 * Authors:  Roman Katargin
 */


#include <ncbi_pch.hpp>
#include <objects/seq/Pubdesc.hpp>

#include <gui/widgets/edit/serial_member_primitive_validators.hpp>

////@begin includes
////@end includes
////@begin includes
////@end includes

#include "remarksandserialnumber_panel.hpp"

#include <wx/sizer.h>
#include <wx/bitmap.h>
#include <wx/icon.h>
#include <wx/stattext.h>
#include <wx/textctrl.h>

BEGIN_NCBI_SCOPE
USING_SCOPE(objects);

////@begin XPM images
////@end XPM images


/*
 * CRemarksAndSerialNumberPanel type definition
 */

IMPLEMENT_DYNAMIC_CLASS( CRemarksAndSerialNumberPanel, wxPanel )


/*
 * CRemarksAndSerialNumberPanel event table definition
 */

BEGIN_EVENT_TABLE( CRemarksAndSerialNumberPanel, wxPanel )

////@begin CRemarksAndSerialNumberPanel event table entries
////@end CRemarksAndSerialNumberPanel event table entries

END_EVENT_TABLE()


/*
 * CRemarksAndSerialNumberPanel constructors
 */

CRemarksAndSerialNumberPanel::CRemarksAndSerialNumberPanel()
{
    Init();
}

CRemarksAndSerialNumberPanel::CRemarksAndSerialNumberPanel( wxWindow* parent, CSerialObject& object,
         wxWindowID id, const wxPoint& pos, const wxSize& size, long style ) :
     m_Object(0)
{
    Init();
    m_Object = dynamic_cast<CPubdesc*>(&object);
    Create(parent, id, pos, size, style);
}


/*
 * CRemarksAndSerialNumberPanel creator
 */

bool CRemarksAndSerialNumberPanel::Create( wxWindow* parent, wxWindowID id, const wxPoint& pos, const wxSize& size, long style )
{
////@begin CRemarksAndSerialNumberPanel creation
    SetExtraStyle(wxWS_EX_BLOCK_EVENTS);
    wxPanel::Create( parent, id, pos, size, style );

    CreateControls();
    if (GetSizer())
    {
        GetSizer()->SetSizeHints(this);
    }
    Centre();
////@end CRemarksAndSerialNumberPanel creation
    return true;
}


/*
 * CRemarksAndSerialNumberPanel destructor
 */

CRemarksAndSerialNumberPanel::~CRemarksAndSerialNumberPanel()
{
////@begin CRemarksAndSerialNumberPanel destruction
////@end CRemarksAndSerialNumberPanel destruction
}


/*
 * Member initialisation
 */

void CRemarksAndSerialNumberPanel::Init()
{
////@begin CRemarksAndSerialNumberPanel member initialisation
////@end CRemarksAndSerialNumberPanel member initialisation
}


/*
 * Control creation for CRemarksAndSerialNumberPanel
 */

void CRemarksAndSerialNumberPanel::CreateControls()
{    
////@begin CRemarksAndSerialNumberPanel content construction
    CRemarksAndSerialNumberPanel* itemPanel1 = this;

    wxBoxSizer* itemBoxSizer2 = new wxBoxSizer(wxVERTICAL);
    itemPanel1->SetSizer(itemBoxSizer2);

    wxStaticText* itemStaticText3 = new wxStaticText( itemPanel1, wxID_STATIC, _("Remark"), wxDefaultPosition, wxDefaultSize, 0 );
    itemBoxSizer2->Add(itemStaticText3, 0, wxALIGN_CENTER_HORIZONTAL|wxALL, 5);

    wxTextCtrl* itemTextCtrl4 = new wxTextCtrl( itemPanel1, ID_REMARK, wxEmptyString, wxDefaultPosition, wxSize(300, -1), wxTE_MULTILINE );
    itemBoxSizer2->Add(itemTextCtrl4, 0, wxALIGN_CENTER_HORIZONTAL|wxALL, 5);

////@end CRemarksAndSerialNumberPanel content construction
    itemTextCtrl4->SetValidator( CSerialTextValidator(*m_Object, "comment") );

}


/*
 * Should we show tooltips?
 */

bool CRemarksAndSerialNumberPanel::ShowToolTips()
{
    return true;
}

/*
 * Get bitmap resources
 */

wxBitmap CRemarksAndSerialNumberPanel::GetBitmapResource( const wxString& name )
{
    // Bitmap retrieval
////@begin CRemarksAndSerialNumberPanel bitmap retrieval
    wxUnusedVar(name);
    return wxNullBitmap;
////@end CRemarksAndSerialNumberPanel bitmap retrieval
}

/*
 * Get icon resources
 */

wxIcon CRemarksAndSerialNumberPanel::GetIconResource( const wxString& name )
{
    // Icon retrieval
////@begin CRemarksAndSerialNumberPanel icon retrieval
    wxUnusedVar(name);
    return wxNullIcon;
////@end CRemarksAndSerialNumberPanel icon retrieval
}
END_NCBI_SCOPE
