/*  $Id: trna_product_panel.hpp 25347 2012-03-01 18:22:54Z katargir $
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data,  the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties,  express or implied,  including
 *  warranties of performance,  merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 * Authors:  Colleen Bollin
 */
#ifndef _TRNA_PRODUCT_PANEL_H_
#define _TRNA_PRODUCT_PANEL_H_

#include <corelib/ncbistd.hpp>

/*!
 * Includes
 */

////@begin includes
////@end includes
#include <wx/panel.h>
#include <wx/sizer.h>
#include <wx/choice.h>
#include <wx/stattext.h>

/*!
 * Forward declarations
 */

////@begin forward declarations
////@end forward declarations

BEGIN_NCBI_SCOPE

/*!
 * Control identifiers
 */

////@begin control identifiers
#define SYMBOL_CTRNAPRODUCTPANEL_STYLE wxTAB_TRAVERSAL
#define SYMBOL_CTRNAPRODUCTPANEL_TITLE _("tRNA Product Panel")
#define SYMBOL_CTRNAPRODUCTPANEL_IDNAME ID_CTRNAPRODUCTPANEL
#define SYMBOL_CTRNAPRODUCTPANEL_SIZE wxSize(400, 300)
#define SYMBOL_CTRNAPRODUCTPANEL_POSITION wxDefaultPosition
////@end control identifiers


/*!
 * CtRNAProductPanel class declaration
 */

class CtRNAProductPanel: public wxPanel
{    
    DECLARE_DYNAMIC_CLASS( CtRNAProductPanel )
    DECLARE_EVENT_TABLE()

public:
    /// Constructors
    CtRNAProductPanel();
    CtRNAProductPanel( wxWindow* parent, CRef<objects::CTrna_ext> trna,
                       wxWindowID id = SYMBOL_CTRNAPRODUCTPANEL_IDNAME, const wxPoint& pos = SYMBOL_CTRNAPRODUCTPANEL_POSITION, const wxSize& size = SYMBOL_CTRNAPRODUCTPANEL_SIZE, long style = SYMBOL_CTRNAPRODUCTPANEL_STYLE );

    /// Creation
    bool Create( wxWindow* parent, wxWindowID id = SYMBOL_CTRNAPRODUCTPANEL_IDNAME, const wxPoint& pos = SYMBOL_CTRNAPRODUCTPANEL_POSITION, const wxSize& size = SYMBOL_CTRNAPRODUCTPANEL_SIZE, long style = SYMBOL_CTRNAPRODUCTPANEL_STYLE );

    /// Destructor
    ~CtRNAProductPanel();

    /// Initialises member variables
    void Init();

    /// Creates the controls and sizers
    void CreateControls();

    virtual bool TransferDataToWindow();
    virtual bool TransferDataFromWindow();


////@begin CtRNAProductPanel event handler declarations

////@end CtRNAProductPanel event handler declarations

////@begin CtRNAProductPanel member function declarations

    /// Retrieves bitmap resources
    wxBitmap GetBitmapResource( const wxString& name );

    /// Retrieves icon resources
    wxIcon GetIconResource( const wxString& name );
////@end CtRNAProductPanel member function declarations

    /// Should we show tooltips?
    static bool ShowToolTips();

////@begin CtRNAProductPanel member variables
    wxChoice* m_AminoAcidCtrl;
    /// Control identifiers
    enum {
        ID_CTRNAPRODUCTPANEL = 10110,
        ID_CHOICE = 10041
    };
////@end CtRNAProductPanel member variables
private:
    CRef<objects::CTrna_ext> m_trna;
    void x_SetAminoAcid ();

};

END_NCBI_SCOPE

#endif
    // _TRNA_PRODUCT_PANEL_H_
