/*  $Id: color_conf.cpp 19013 2009-03-24 19:03:05Z dicuccio $
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 * Authors:  Vlad Lebedev
 *
 * File Description:
 *
 */

#include <ncbi_pch.hpp>
#include <gui/widgets/seq_graphic/color_conf.hpp>
#include <gui/config/settings_set.hpp>
#include <string>
#include <map>

BEGIN_NCBI_SCOPE

// Here this include defines colorelement2str and its associated data structure.
#define DEFINE_COLOR_ELEMENTS
#include <gui/widgets/seq_graphic/color_elements.hpp>


CSeqGraphicColorConfig::CSeqGraphicColorConfig(const CSettingsSet& settings)
: m_Settings(settings)
{}


CRgbaColor CSeqGraphicColorConfig::GetElementColor(EDisplayElement e) const
{
    return m_Settings.GetColor(colorelement2str(e));
}


CSeqGraphicColorConfigWrite::CSeqGraphicColorConfigWrite(CSettingsSet& settings)
: CSeqGraphicColorConfig(settings),
  m_Settings(settings)
{}


void CSeqGraphicColorConfigWrite::SetElementColor(EDisplayElement e, const CRgbaColor& c)
{
    m_Settings.Set(colorelement2str(e), c);
}


END_NCBI_SCOPE
