/*  $Id: content_check_dialog.cpp 19013 2009-03-24 19:03:05Z dicuccio $
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 * Authors:  Liangshou Wu
 *
 * File Description:
 *
 */
// Generated by DialogBlocks (unregistered), 05/09/2008 14:10:25

#include <ncbi_pch.hpp>////@begin includes
////@end includes

#include <objects/seqfeat/Seq_feat.hpp>
#include <objects/seqfeat/SeqFeatData.hpp>
#include <gui/widgets/seq_graphic/seqgraphic_conf.hpp>

#include <wx/panel.h>
#include <wx/stattext.h>
#include <wx/button.h>
#include <wx/bitmap.h>
#include <wx/icon.h>
#include <wx/sizer.h>
#include <wx/statbox.h>
#include <gui/widgets/seq/feature_check_panel.hpp>

#include "content_check_dialog.hpp"
#include "extra_feature_panel.hpp"


////@begin XPM images
////@end XPM images

BEGIN_NCBI_SCOPE

IMPLEMENT_DYNAMIC_CLASS( CContentCheckDialog, wxDialog )

BEGIN_EVENT_TABLE( CContentCheckDialog, wxDialog )

////@begin CContentCheckDialog event table entries
    EVT_BUTTON( wxID_OK, CContentCheckDialog::OnOkClick )

////@end CContentCheckDialog event table entries

END_EVENT_TABLE()

CContentCheckDialog::CContentCheckDialog()
{
    Init();
}

CContentCheckDialog::CContentCheckDialog( wxWindow* parent, wxWindowID id, const wxString& caption, const wxPoint& pos, const wxSize& size, long style )
{
    Init();
    Create(parent, id, caption, pos, size, style);
}

bool CContentCheckDialog::Create( wxWindow* parent, wxWindowID id, const wxString& caption, const wxPoint& pos, const wxSize& size, long style )
{
////@begin CContentCheckDialog creation
    SetExtraStyle(wxWS_EX_BLOCK_EVENTS);
    wxDialog::Create( parent, id, caption, pos, size, style );

    CreateControls();
    if (GetSizer())
    {
        GetSizer()->SetSizeHints(this);
    }
    Centre();
////@end CContentCheckDialog creation
    return true;
}

CContentCheckDialog::~CContentCheckDialog()
{
////@begin CContentCheckDialog destruction
////@end CContentCheckDialog destruction
}

void CContentCheckDialog::Init()
{
////@begin CContentCheckDialog member initialisation
    m_FeatPanel = NULL;
    m_ExtraFeatPanel = NULL;
////@end CContentCheckDialog member initialisation
}

void CContentCheckDialog::CreateControls()
{
////@begin CContentCheckDialog content construction
    // Generated by DialogBlocks, 05/09/2008 16:38:07 (unregistered)

    CContentCheckDialog* itemDialog1 = this;

    wxBoxSizer* itemBoxSizer2 = new wxBoxSizer(wxVERTICAL);
    itemDialog1->SetSizer(itemBoxSizer2);

    wxBoxSizer* itemBoxSizer3 = new wxBoxSizer(wxHORIZONTAL);
    itemBoxSizer2->Add(itemBoxSizer3, 1, wxGROW|wxALL, 5);

    wxStaticBox* itemStaticBoxSizer4Static = new wxStaticBox(itemDialog1, wxID_ANY, _("Feature list"));
    wxStaticBoxSizer* itemStaticBoxSizer4 = new wxStaticBoxSizer(itemStaticBoxSizer4Static, wxVERTICAL);
    itemBoxSizer3->Add(itemStaticBoxSizer4, 1, wxGROW|wxALL, 5);

    m_FeatPanel = new CFeatureCheckPanel( itemDialog1, ID_PANEL2, wxDefaultPosition, wxDefaultSize, wxTAB_TRAVERSAL );
    itemStaticBoxSizer4->Add(m_FeatPanel, 1, wxGROW|wxALL, 5);

    wxStaticBox* itemStaticBoxSizer6Static = new wxStaticBox(itemDialog1, wxID_ANY, _("Extra feature list"));
    wxStaticBoxSizer* itemStaticBoxSizer6 = new wxStaticBoxSizer(itemStaticBoxSizer6Static, wxVERTICAL);
    itemBoxSizer3->Add(itemStaticBoxSizer6, 1, wxGROW|wxALL, 5);

    m_ExtraFeatPanel = new CExtraFeaturePanel( itemDialog1, ID_PANEL3, wxDefaultPosition, wxDefaultSize, wxTAB_TRAVERSAL );
    itemStaticBoxSizer6->Add(m_ExtraFeatPanel, 1, wxGROW|wxALL, 5);

    wxStaticLine* itemStaticLine8 = new wxStaticLine( itemDialog1, wxID_STATIC, wxDefaultPosition, wxDefaultSize, wxLI_HORIZONTAL );
    itemBoxSizer2->Add(itemStaticLine8, 0, wxGROW|wxALL, 5);

    wxBoxSizer* itemBoxSizer9 = new wxBoxSizer(wxHORIZONTAL);
    itemBoxSizer2->Add(itemBoxSizer9, 0, wxALIGN_RIGHT|wxALL, 5);

    wxButton* itemButton10 = new wxButton( itemDialog1, wxID_OK, _("&OK"), wxDefaultPosition, wxDefaultSize, 0 );
    itemBoxSizer9->Add(itemButton10, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5);

    wxButton* itemButton11 = new wxButton( itemDialog1, wxID_CANCEL, _("&Cancel"), wxDefaultPosition, wxDefaultSize, 0 );
    itemBoxSizer9->Add(itemButton11, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5);

////@end CContentCheckDialog content construction
}

bool CContentCheckDialog::ShowToolTips()
{
    return true;
}
wxBitmap CContentCheckDialog::GetBitmapResource( const wxString& name )
{
    // Bitmap retrieval
////@begin CContentCheckDialog bitmap retrieval
    wxUnusedVar(name);
    return wxNullBitmap;
////@end CContentCheckDialog bitmap retrieval
}
wxIcon CContentCheckDialog::GetIconResource( const wxString& name )
{
    // Icon retrieval
////@begin CContentCheckDialog icon retrieval
    wxUnusedVar(name);
    return wxNullIcon;
////@end CContentCheckDialog icon retrieval
}

void CContentCheckDialog::SetConfig(CRef<CSeqGraphicConfig> cfg)
{		
	m_Cfg.Reset(cfg);	
    m_ExtraFeatPanel->SetConfig(cfg);

    CFeatureCheckPanel::TFeatTypeItemSet items_set;
	const objects::CFeatList* feat_list = objects::CSeqFeatData::GetFeatList();

	// populate checks
	ITERATE(objects::CFeatList, feat, *feat_list) {
		if (m_Cfg->GetShow(feat->GetSubtype())) {
			items_set.insert(*feat);
		}
	}
	m_FeatPanel->SetSelected(items_set);
}

void CContentCheckDialog::OnOkClick( wxCommandEvent& event )
{
    m_ExtraFeatPanel->TransferDataFromPanel();

    CFeatureCheckPanel::TFeatTypeItemSet items_set;
	const objects::CFeatList* feat_list = objects::CSeqFeatData::GetFeatList();

    m_FeatPanel->GetSelected(items_set);

    // this interface is so inconvenient
    // it needs to be reworked
    ITERATE(objects::CFeatList, feat, *feat_list) {
        m_Cfg->SetShow(feat->GetSubtype(), false);		
    }

    ITERATE(CFeatureCheckPanel::TFeatTypeItemSet, item, items_set){
        m_Cfg->SetShow(item->GetSubtype(), true);		
    }

    event.Skip();
}

END_NCBI_SCOPE
