/*  $Id: content_check_dialog.hpp 19013 2009-03-24 19:03:05Z dicuccio $
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 * Authors:  Liangshou Wu
 *
 * File Description:
 *
 */
// Generated by DialogBlocks (unregistered), 05/09/2008 14:10:25

#ifndef _CONTENT_CHECK_DIALOG_H_
#define _CONTENT_CHECK_DIALOG_H_


/*!
 * Includes
 */

////@begin includes
#include "wx/statline.h"
////@end includes

#include <corelib/ncbistd.hpp>
#include <wx/sizer.h>
#include <wx/dialog.h>


BEGIN_NCBI_SCOPE

/*!
 * Forward declarations
 */

////@begin forward declarations
class CFeatureCheckPanel;
class CExtraFeaturePanel;
////@end forward declarations

class CSeqGraphicConfig;

/*!
 * Control identifiers
 */

////@begin control identifiers
#define ID_CCONTENTCHECKDIALOG 10017
#define ID_PANEL2 10018
#define ID_PANEL3 10019
#define SYMBOL_CCONTENTCHECKDIALOG_STYLE wxCAPTION|wxRESIZE_BORDER|wxSYSTEM_MENU|wxCLOSE_BOX|wxTAB_TRAVERSAL
#define SYMBOL_CCONTENTCHECKDIALOG_TITLE _("Content Check Dialog")
#define SYMBOL_CCONTENTCHECKDIALOG_IDNAME ID_CCONTENTCHECKDIALOG
#define SYMBOL_CCONTENTCHECKDIALOG_SIZE wxSize(200, 300)
#define SYMBOL_CCONTENTCHECKDIALOG_POSITION wxDefaultPosition
////@end control identifiers


/*!
 * CContentCheckDialog class declaration
 */

class CContentCheckDialog: public wxDialog
{
    DECLARE_DYNAMIC_CLASS( CContentCheckDialog )
    DECLARE_EVENT_TABLE()

public:
    CContentCheckDialog();
    CContentCheckDialog( wxWindow* parent, wxWindowID id = SYMBOL_CCONTENTCHECKDIALOG_IDNAME, const wxString& caption = SYMBOL_CCONTENTCHECKDIALOG_TITLE, const wxPoint& pos = SYMBOL_CCONTENTCHECKDIALOG_POSITION, const wxSize& size = SYMBOL_CCONTENTCHECKDIALOG_SIZE, long style = SYMBOL_CCONTENTCHECKDIALOG_STYLE );

    bool Create( wxWindow* parent, wxWindowID id = SYMBOL_CCONTENTCHECKDIALOG_IDNAME, const wxString& caption = SYMBOL_CCONTENTCHECKDIALOG_TITLE, const wxPoint& pos = SYMBOL_CCONTENTCHECKDIALOG_POSITION, const wxSize& size = SYMBOL_CCONTENTCHECKDIALOG_SIZE, long style = SYMBOL_CCONTENTCHECKDIALOG_STYLE );

    ~CContentCheckDialog();

    void Init();

    void CreateControls();

////@begin CContentCheckDialog event handler declarations

    void OnOkClick( wxCommandEvent& event );

////@end CContentCheckDialog event handler declarations

////@begin CContentCheckDialog member function declarations

    wxBitmap GetBitmapResource( const wxString& name );

    wxIcon GetIconResource( const wxString& name );
////@end CContentCheckDialog member function declarations

    static bool ShowToolTips();

////@begin CContentCheckDialog member variables
    CFeatureCheckPanel* m_FeatPanel;
    CExtraFeaturePanel* m_ExtraFeatPanel;
////@end CContentCheckDialog member variables

   	void SetConfig(CRef<CSeqGraphicConfig> cfg);

private:
  	CRef<CSeqGraphicConfig> m_Cfg;

};

END_NCBI_SCOPE

#endif
    // _CONTENT_CHECK_DIALOG_H_
