/*  $Id: extra_feature_panel.cpp 25628 2012-04-13 17:49:41Z katargir $
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 * Authors:  Liangshou wu
 *
 * File Description:
 *
 */
// Generated by DialogBlocks (unregistered), 05/09/2008 10:10:48

#include <ncbi_pch.hpp>////@begin includes
////@end includes

#include <gui/widgets/seq_graphic/seqgraphic_conf.hpp>
#include <objects/seqfeat/SeqFeatData.hpp>

#include <wx/bitmap.h>
#include <wx/icon.h>
#include <wx/sizer.h>
#include <gui/widgets/wx/treectrl_ex.hpp>

#include "extra_feature_panel.hpp"

////@begin XPM images
////@end XPM images

BEGIN_NCBI_SCOPE

IMPLEMENT_DYNAMIC_CLASS( CExtraFeaturePanel, wxPanel )

BEGIN_EVENT_TABLE( CExtraFeaturePanel, wxPanel )

////@begin CExtraFeaturePanel event table entries
////@end CExtraFeaturePanel event table entries

END_EVENT_TABLE()

CExtraFeaturePanel::CExtraFeaturePanel()
{
    Init();
}

CExtraFeaturePanel::CExtraFeaturePanel( wxWindow* parent, wxWindowID id, const wxPoint& pos, const wxSize& size, long style )
{
    Init();
    Create(parent, id, pos, size, style);
}

bool CExtraFeaturePanel::Create( wxWindow* parent, wxWindowID id, const wxPoint& pos, const wxSize& size, long style )
{
////@begin CExtraFeaturePanel creation
    wxPanel::Create( parent, id, pos, size, style );

    CreateControls();
    if (GetSizer())
    {
        GetSizer()->SetSizeHints(this);
    }
    Centre();
////@end CExtraFeaturePanel creation
    return true;
}

CExtraFeaturePanel::~CExtraFeaturePanel()
{
////@begin CExtraFeaturePanel destruction
////@end CExtraFeaturePanel destruction
}

void CExtraFeaturePanel::Init()
{
////@begin CExtraFeaturePanel member initialisation
    m_Tree = NULL;
////@end CExtraFeaturePanel member initialisation
}

void CExtraFeaturePanel::CreateControls()
{
////@begin CExtraFeaturePanel content construction
    // Generated by DialogBlocks, 05/09/2008 16:35:17 (unregistered)

    CExtraFeaturePanel* itemPanel1 = this;

    wxBoxSizer* itemBoxSizer2 = new wxBoxSizer(wxVERTICAL);
    itemPanel1->SetSizer(itemBoxSizer2);

    m_Tree = new CwxTreeCtrlEx( itemPanel1, ID_TREECTRL1, wxDefaultPosition, wxSize(180, 180), wxTR_HAS_BUTTONS |wxTR_SINGLE );
    itemBoxSizer2->Add(m_Tree, 1, wxGROW|wxALL, 5);

////@end CExtraFeaturePanel content construction

    x_InitTree();
}

bool CExtraFeaturePanel::ShowToolTips()
{
    return true;
}

wxBitmap CExtraFeaturePanel::GetBitmapResource( const wxString& name )
{
    // Bitmap retrieval
////@begin CExtraFeaturePanel bitmap retrieval
    wxUnusedVar(name);
    return wxNullBitmap;
////@end CExtraFeaturePanel bitmap retrieval
}

wxIcon CExtraFeaturePanel::GetIconResource( const wxString& name )
{
    // Icon retrieval
////@begin CExtraFeaturePanel icon retrieval
    wxUnusedVar(name);
    return wxNullIcon;
////@end CExtraFeaturePanel icon retrieval
}

void CExtraFeaturePanel::SetConfig(CRef<CSeqGraphicConfig> cfg)
{		
	m_Cfg.Reset(cfg);

    wxTreeItemIdValue cookie;
    wxTreeItemId cid = m_Tree->GetFirstChild(m_Tree->GetRootItem(), cookie);
    for (;  cid.IsOk();  cid=m_Tree->GetNextChild(m_Tree->GetRootItem(), cookie)){
		const wxExtraFeatItemData* fi = dynamic_cast<wxExtraFeatItemData*>(m_Tree->GetItemData(cid));
        const string& key = fi->GetKey();
        bool bCheck = false;
        if (key == "ShowAlignments") {
            bCheck = m_Cfg->GetShowAlignments();
        } else if (key == "ShowAlignmentFeats") {
            bCheck = m_Cfg->GetShowAlignmentFeats();
        } else if (key == "ShowCDSProductFeats") {
            bCheck = m_Cfg->GetShowCDSProductFeats();
        } else if (key == "ShowGraphs") {
            bCheck = m_Cfg->GetShowGraphs();
        } else if (key == "ShowSwitchPoints") {
            bCheck = m_Cfg->GetShowSwitchPoints();
        } else if (key == "ShowSegmentMap") {
            bCheck = m_Cfg->GetShowSegmentMap();
        }

        m_Tree->SetCheck(cid, bCheck);
    }
}

void CExtraFeaturePanel::TransferDataFromPanel(void)
{
    wxTreeItemIdValue cookie;
    wxTreeItemId cid = m_Tree->GetFirstChild(m_Tree->GetRootItem(), cookie);
    for (;  cid.IsOk();  cid=m_Tree->GetNextChild(m_Tree->GetRootItem(), cookie)){
		const wxExtraFeatItemData* fi = dynamic_cast<wxExtraFeatItemData*>(m_Tree->GetItemData(cid));
        const string& key = fi->GetKey();
        bool bCheck = m_Tree->GetCheck(cid);
        if (key == "ShowAlignments") {
            m_Cfg->SetShowAlignments(bCheck);
        } else if (key == "ShowAlignmentFeats") {
            m_Cfg->SetShowAlignmentFeats(bCheck);
        } else if (key == "ShowCDSProductFeats") {
            m_Cfg->SetShowCDSProductFeats(bCheck);
        } else if (key == "ShowGraphs") {
            m_Cfg->SetShowGraphs(bCheck);
        } else if (key == "ShowSwitchPoints") {
            m_Cfg->SetShowSwitchPoints(bCheck);
        } else if (key == "ShowSegmentMap") {
            m_Cfg->SetShowSegmentMap(bCheck);
        }
    }
}

void CExtraFeaturePanel::x_InitTree(void)
{
	wxTreeItemId root_id = m_Tree->AddRoot(wxT("All Extra Feature Types"));
    m_Tree->AppendItem(root_id, wxT("Alignments"), -1, -1,
        new wxExtraFeatItemData("ShowAlignments"));
    m_Tree->AppendItem(root_id, wxT("Alignment Features"), -1, -1,
        new wxExtraFeatItemData("ShowAlignmentFeats"));
    m_Tree->AppendItem(root_id, wxT("CDS Product Features"), -1, -1,
        new wxExtraFeatItemData("ShowCDSProductFeats"));
    m_Tree->AppendItem(root_id, wxT("Graphs"), -1, -1,
        new wxExtraFeatItemData("ShowGraphs"));
    m_Tree->AppendItem(root_id, wxT("Switch Points"), -1, -1,
        new wxExtraFeatItemData("ShowSwitchPoints"));
    m_Tree->AppendItem(root_id, wxT("Segment Map"), -1, -1,
        new wxExtraFeatItemData("ShowSegmentMap"));

	m_Tree->Expand(root_id);
	m_Tree->CheckAll(false);
}

END_NCBI_SCOPE
