/*  $Id: wx_histogram_config_dlg.cpp 26807 2012-11-08 20:22:19Z wuliangs $
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 * Authors:  Liangshou Wu
 *
 * File Description:
 *
 */
// Generated by DialogBlocks (unregistered), 30/11/2008 23:01:05

#include <ncbi_pch.hpp>////@begin includes
////@end includes


#include "wx_histogram_config_dlg.hpp"
#include <gui/widgets/wx/color_picker_validator.hpp>
#include <gui/widgets/wx/wx_utils.hpp>
#include <wx/bitmap.h>
#include <wx/icon.h>
#include <wx/statbox.h>
#include <wx/textctrl.h>
#include <wx/checkbox.h>
#include <wx/slider.h>
#include <wx/radiobut.h>
#include <wx/stattext.h>
////@begin XPM images
////@end XPM images

BEGIN_NCBI_SCOPE


IMPLEMENT_DYNAMIC_CLASS( CHistConfigDlg, wxDialog )

BEGIN_EVENT_TABLE( CHistConfigDlg, wxDialog )

////@begin CHistConfigDlg event table entries
    EVT_RADIOBUTTON( ID_RADIOBUTTON1, CHistConfigDlg::OnSmearBarSelected )

    EVT_RADIOBUTTON( ID_RADIOBUTTON2, CHistConfigDlg::OnHistogramSelected )

    EVT_RADIOBUTTON( ID_RADIOBUTTON3, CHistConfigDlg::OnLineGraphSelected )

    EVT_CHECKBOX( ID_CHECKBOX5, CHistConfigDlg::OnShowRulerClick )

    EVT_CHECKBOX( ID_CHECKBOX4, CHistConfigDlg::OnDrawBackgroundClick )

    EVT_TEXT( ID_TEXTCTRL2, CHistConfigDlg::OnHeightUpdated )

    EVT_COLOURPICKER_CHANGED( ID_COLOURPICKERCTRL3, CHistConfigDlg::OnBGColorChanged )

    EVT_SLIDER( ID_SLIDER1, CHistConfigDlg::OnOpacityUpdated )

////@end CHistConfigDlg event table entries

END_EVENT_TABLE()

CHistConfigDlg::CHistConfigDlg()
{
    Init();
}

CHistConfigDlg::CHistConfigDlg( wxWindow* parent, wxWindowID id, const wxString& caption, const wxPoint& pos, const wxSize& size, long style )
{
    Init();
    CreateX(parent, id, caption, pos, size, style);
}

bool CHistConfigDlg::CreateX( wxWindow* parent, wxWindowID id, const wxString& caption, const wxPoint& pos, const wxSize& size, long style )
{
////@begin CHistConfigDlg creation
    SetExtraStyle(wxWS_EX_BLOCK_EVENTS);
    wxDialog::Create( parent, id, caption, pos, size, style );

    CreateControls();
    Centre();
////@end CHistConfigDlg creation
    return true;
}

CHistConfigDlg::~CHistConfigDlg()
{
////@begin CHistConfigDlg destruction
////@end CHistConfigDlg destruction
}

void CHistConfigDlg::Init()
{
////@begin CHistConfigDlg member initialisation
    m_HistName = NULL;
    m_SmearBar = NULL;
    m_Histogram = NULL;
    m_LineGraph = NULL;
    m_Height = NULL;
    m_ColorBox = NULL;
    m_fgColor = NULL;
    m_BgColorGroup = NULL;
    m_bgColor = NULL;
    m_Opacity = NULL;
    m_RulerColorGroup = NULL;
    m_LabelColor = NULL;
    m_SmearColorGroup = NULL;
    m_ColorMin = NULL;
    m_ColorMax = NULL;
////@end CHistConfigDlg member initialisation
}

void CHistConfigDlg::CreateControls()
{    
////@begin CHistConfigDlg content construction
    CHistConfigDlg* itemDialog1 = this;

    wxBoxSizer* itemBoxSizer2 = new wxBoxSizer(wxVERTICAL);
    itemDialog1->SetSizer(itemBoxSizer2);

    m_HistName = new wxStaticText( itemDialog1, wxID_STATIC, _("Histogram settings for "), wxDefaultPosition, wxDefaultSize, 0 );
    itemBoxSizer2->Add(m_HistName, 0, wxALIGN_CENTER_HORIZONTAL|wxLEFT|wxRIGHT|wxTOP, 5);

    wxStaticLine* itemStaticLine4 = new wxStaticLine( itemDialog1, wxID_STATIC, wxDefaultPosition, wxDefaultSize, wxLI_HORIZONTAL );
    itemBoxSizer2->Add(itemStaticLine4, 0, wxGROW|wxLEFT|wxRIGHT|wxBOTTOM, 5);

    wxStaticBox* itemStaticBoxSizer5Static = new wxStaticBox(itemDialog1, wxID_ANY, _("Rendering style"));
    wxStaticBoxSizer* itemStaticBoxSizer5 = new wxStaticBoxSizer(itemStaticBoxSizer5Static, wxHORIZONTAL);
    itemBoxSizer2->Add(itemStaticBoxSizer5, 0, wxGROW|wxALL, 5);

    m_SmearBar = new wxRadioButton( itemDialog1, ID_RADIOBUTTON1, _("Smear bar"), wxDefaultPosition, wxDefaultSize, wxRB_GROUP );
    m_SmearBar->SetValue(false);
    itemStaticBoxSizer5->Add(m_SmearBar, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5);

    itemStaticBoxSizer5->Add(5, 5, 1, wxGROW|wxLEFT|wxRIGHT, 5);

    m_Histogram = new wxRadioButton( itemDialog1, ID_RADIOBUTTON2, _("Histogram"), wxDefaultPosition, wxDefaultSize, 0 );
    m_Histogram->SetValue(false);
    itemStaticBoxSizer5->Add(m_Histogram, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5);

    itemStaticBoxSizer5->Add(5, 5, 1, wxGROW|wxLEFT|wxRIGHT, 5);

    m_LineGraph = new wxRadioButton( itemDialog1, ID_RADIOBUTTON3, _("Line graph"), wxDefaultPosition, wxDefaultSize, 0 );
    m_LineGraph->SetValue(false);
    itemStaticBoxSizer5->Add(m_LineGraph, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5);

    wxStaticBox* itemStaticBoxSizer11Static = new wxStaticBox(itemDialog1, wxID_ANY, wxEmptyString);
    wxStaticBoxSizer* itemStaticBoxSizer11 = new wxStaticBoxSizer(itemStaticBoxSizer11Static, wxHORIZONTAL);
    itemBoxSizer2->Add(itemStaticBoxSizer11, 0, wxGROW|wxLEFT|wxRIGHT, 5);

    wxBoxSizer* itemBoxSizer12 = new wxBoxSizer(wxHORIZONTAL);
    itemStaticBoxSizer11->Add(itemBoxSizer12, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5);

    wxCheckBox* itemCheckBox13 = new wxCheckBox( itemDialog1, ID_CHECKBOX5, _("Show ruler"), wxDefaultPosition, wxDefaultSize, 0 );
    itemCheckBox13->SetValue(true);
    itemBoxSizer12->Add(itemCheckBox13, 0, wxALIGN_CENTER_VERTICAL|wxTOP|wxBOTTOM, 5);

    itemBoxSizer12->Add(5, 5, 1, wxGROW|wxLEFT|wxRIGHT, 5);

    wxCheckBox* itemCheckBox15 = new wxCheckBox( itemDialog1, ID_CHECKBOX4, _("Draw background"), wxDefaultPosition, wxDefaultSize, 0 );
    itemCheckBox15->SetValue(false);
    itemBoxSizer12->Add(itemCheckBox15, 0, wxALIGN_CENTER_VERTICAL|wxTOP|wxBOTTOM, 5);

    itemBoxSizer12->Add(5, 5, 1, wxGROW|wxLEFT|wxRIGHT, 5);

    wxStaticText* itemStaticText17 = new wxStaticText( itemDialog1, wxID_STATIC, _("Height"), wxDefaultPosition, wxDefaultSize, 0 );
    itemBoxSizer12->Add(itemStaticText17, 0, wxALIGN_CENTER_VERTICAL|wxLEFT|wxRIGHT, 5);

    m_Height = new wxTextCtrl( itemDialog1, ID_TEXTCTRL2, wxEmptyString, wxDefaultPosition, wxSize(40, -1), 0 );
    itemBoxSizer12->Add(m_Height, 0, wxALIGN_CENTER_VERTICAL|wxRIGHT|wxTOP|wxBOTTOM, 5);

    m_ColorBox = new wxStaticBox(itemDialog1, wxID_ANY, _("Color"));
    wxStaticBoxSizer* itemStaticBoxSizer19 = new wxStaticBoxSizer(m_ColorBox, wxVERTICAL);
    itemBoxSizer2->Add(itemStaticBoxSizer19, 0, wxGROW|wxALL, 5);

    wxBoxSizer* itemBoxSizer20 = new wxBoxSizer(wxHORIZONTAL);
    itemStaticBoxSizer19->Add(itemBoxSizer20, 0, wxALIGN_LEFT, 5);

    m_fgColor = new wxColourPickerCtrl( itemDialog1, ID_COLOURPICKERCTRL4, wxColour(), wxDefaultPosition, wxDefaultSize, wxCLRP_DEFAULT_STYLE );
    itemBoxSizer20->Add(m_fgColor, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5);

    wxStaticText* itemStaticText22 = new wxStaticText( itemDialog1, wxID_STATIC, _("Foreground color"), wxDefaultPosition, wxDefaultSize, 0 );
    itemBoxSizer20->Add(itemStaticText22, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5);

    m_BgColorGroup = new wxBoxSizer(wxHORIZONTAL);
    itemStaticBoxSizer19->Add(m_BgColorGroup, 0, wxALIGN_LEFT, 5);

    m_bgColor = new wxColourPickerCtrl( itemDialog1, ID_COLOURPICKERCTRL3, wxColour(), wxDefaultPosition, wxDefaultSize, wxCLRP_DEFAULT_STYLE );
    m_BgColorGroup->Add(m_bgColor, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5);

    wxStaticText* itemStaticText25 = new wxStaticText( itemDialog1, wxID_STATIC, _("Background color"), wxDefaultPosition, wxDefaultSize, 0 );
    m_BgColorGroup->Add(itemStaticText25, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5);

    m_BgColorGroup->Add(5, 5, 1, wxGROW|wxALL, 5);

    m_Opacity = new wxSlider( itemDialog1, ID_SLIDER1, 40, 0, 255, wxDefaultPosition, wxSize(100, 20), wxSL_HORIZONTAL );
    m_BgColorGroup->Add(m_Opacity, 0, wxALIGN_CENTER_VERTICAL|wxLEFT|wxTOP|wxBOTTOM, 5);

    wxStaticText* itemStaticText28 = new wxStaticText( itemDialog1, wxID_STATIC, _("Opacity"), wxDefaultPosition, wxDefaultSize, 0 );
    m_BgColorGroup->Add(itemStaticText28, 0, wxALIGN_CENTER_VERTICAL, 5);

    m_RulerColorGroup = new wxBoxSizer(wxHORIZONTAL);
    itemStaticBoxSizer19->Add(m_RulerColorGroup, 0, wxALIGN_LEFT, 5);

    m_LabelColor = new wxColourPickerCtrl( itemDialog1, ID_COLOURPICKERCTRL5, wxColour(), wxDefaultPosition, wxDefaultSize, wxCLRP_DEFAULT_STYLE );
    m_RulerColorGroup->Add(m_LabelColor, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5);

    wxStaticText* itemStaticText31 = new wxStaticText( itemDialog1, wxID_STATIC, _("Label color"), wxDefaultPosition, wxDefaultSize, 0 );
    m_RulerColorGroup->Add(itemStaticText31, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5);

    m_RulerColorGroup->Add(15, 5, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5);

    wxColourPickerCtrl* itemColourPickerCtrl33 = new wxColourPickerCtrl( itemDialog1, ID_COLOURPICKERCTRL8, wxColour(), wxDefaultPosition, wxDefaultSize, wxCLRP_DEFAULT_STYLE );
    m_RulerColorGroup->Add(itemColourPickerCtrl33, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5);

    wxStaticText* itemStaticText34 = new wxStaticText( itemDialog1, wxID_STATIC, _("Ruler color"), wxDefaultPosition, wxDefaultSize, 0 );
    m_RulerColorGroup->Add(itemStaticText34, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5);

    m_SmearColorGroup = new wxBoxSizer(wxHORIZONTAL);
    itemStaticBoxSizer19->Add(m_SmearColorGroup, 0, wxALIGN_LEFT, 5);

    m_ColorMin = new wxColourPickerCtrl( itemDialog1, ID_COLOURPICKERCTRL6, wxColour(), wxDefaultPosition, wxDefaultSize, wxCLRP_DEFAULT_STYLE );
    m_SmearColorGroup->Add(m_ColorMin, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5);

    wxStaticText* itemStaticText37 = new wxStaticText( itemDialog1, wxID_STATIC, _("Smear color min"), wxDefaultPosition, wxDefaultSize, 0 );
    m_SmearColorGroup->Add(itemStaticText37, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5);

    m_ColorMax = new wxColourPickerCtrl( itemDialog1, ID_COLOURPICKERCTRL7, wxColour(), wxDefaultPosition, wxDefaultSize, wxCLRP_DEFAULT_STYLE );
    m_SmearColorGroup->Add(m_ColorMax, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5);

    wxStaticText* itemStaticText39 = new wxStaticText( itemDialog1, wxID_STATIC, _("Smear color max"), wxDefaultPosition, wxDefaultSize, 0 );
    m_SmearColorGroup->Add(itemStaticText39, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5);

    itemBoxSizer2->Add(5, 10, 1, wxGROW|wxALL, 5);

    wxStaticLine* itemStaticLine41 = new wxStaticLine( itemDialog1, wxID_STATIC, wxDefaultPosition, wxDefaultSize, wxLI_HORIZONTAL );
    itemBoxSizer2->Add(itemStaticLine41, 0, wxGROW|wxALL, 5);

    wxStdDialogButtonSizer* itemStdDialogButtonSizer42 = new wxStdDialogButtonSizer;

    itemBoxSizer2->Add(itemStdDialogButtonSizer42, 0, wxALIGN_RIGHT|wxALL, 5);
    wxButton* itemButton43 = new wxButton( itemDialog1, wxID_OK, _("&OK"), wxDefaultPosition, wxDefaultSize, 0 );
    itemButton43->SetDefault();
    itemStdDialogButtonSizer42->AddButton(itemButton43);

    wxButton* itemButton44 = new wxButton( itemDialog1, wxID_CANCEL, _("&Cancel"), wxDefaultPosition, wxDefaultSize, 0 );
    itemStdDialogButtonSizer42->AddButton(itemButton44);

    itemStdDialogButtonSizer42->Realize();

    // Set validators
    itemCheckBox13->SetValidator( wxGenericValidator(& m_Config->m_NeedRuler) );
    itemCheckBox15->SetValidator( wxGenericValidator(& m_Config->m_DrawBg) );
    m_fgColor->SetValidator( CColorPickerValidator(& m_Config->m_fgColor) );
    m_bgColor->SetValidator( CColorPickerValidator(& m_Config->m_bgColor) );
    m_LabelColor->SetValidator( CColorPickerValidator(& m_Config->m_LabelColor) );
    itemColourPickerCtrl33->SetValidator( CColorPickerValidator(& m_Config->m_RulerColor) );
    m_ColorMin->SetValidator( CColorPickerValidator(& m_Config->m_SmearColorMin) );
    m_ColorMax->SetValidator( CColorPickerValidator(& m_Config->m_SmearColorMax) );
////@end CHistConfigDlg content construction
    CHistParams::EType type = m_Config->m_Type;
    m_SmearBar->SetValue(type == CHistParams::eSmearBar);
    m_Histogram->SetValue(type == CHistParams::eHistogram);
    m_LineGraph->SetValue(type == CHistParams::eLineGraph);
    m_SmearColorGroup->Show(type == CHistParams::eSmearBar);
    m_RulerColorGroup->Show(m_Config->m_NeedRuler);
    m_BgColorGroup->Show(m_Config->m_DrawBg);

    m_Height->SetValue(ToWxString(NStr::DoubleToString(m_Config->m_Height)));
    m_Opacity->SetValue((int)(m_Config->m_bgColor.GetAlpha() * 255));
    //wxColor color;
    //color.Set(m_Config->m_bgColor.GetRedUC(),
    //    m_Config->m_bgColor.GetGreenUC(),
    //    m_Config->m_bgColor.GetBlueUC(),
    //    m_Config->m_bgColor.GetAlphaUC());
    //m_bgColor->SetColour(color);

    string title = "Histogram settings for " + m_ConfName;
    m_HistName->SetLabel(ToWxString(title));
    Layout();
}

bool CHistConfigDlg::ShowToolTips()
{
    return true;
}
wxBitmap CHistConfigDlg::GetBitmapResource( const wxString& name )
{
    // Bitmap retrieval
////@begin CHistConfigDlg bitmap retrieval
    wxUnusedVar(name);
    return wxNullBitmap;
////@end CHistConfigDlg bitmap retrieval
}
wxIcon CHistConfigDlg::GetIconResource( const wxString& name )
{
    // Icon retrieval
////@begin CHistConfigDlg icon retrieval
    wxUnusedVar(name);
    return wxNullIcon;
////@end CHistConfigDlg icon retrieval
}

void CHistConfigDlg::SetConfig(CRef<CHistParams> config)
{
    m_Config.Reset(new CHistParams(*config));
}

void CHistConfigDlg::OnSmearBarSelected( wxCommandEvent& event )
{
    m_Config->m_Type = CHistParams::eSmearBar;
    m_SmearColorGroup->Show(true);
    Layout();
}

void CHistConfigDlg::OnHistogramSelected( wxCommandEvent& event )
{
    m_Config->m_Type = CHistParams::eHistogram;
    m_SmearColorGroup->Show(false);
    Layout();
}

void CHistConfigDlg::OnLineGraphSelected( wxCommandEvent& event )
{
    m_Config->m_Type = CHistParams::eLineGraph;
    m_SmearColorGroup->Show(false);
    Layout();
}

void CHistConfigDlg::OnHeightUpdated( wxCommandEvent& event )
{
    try {
        m_Config->m_Height = NStr::StringToDouble(ToStdString(m_Height->GetValue()));
    } catch (...) {
        // invalid number no change
    }
}


void CHistConfigDlg::OnOpacityUpdated( wxCommandEvent& event )
{
    m_Config->m_bgColor.SetAlpha((unsigned char)m_Opacity->GetValue());
    wxColor color;
    color.Set(m_Config->m_bgColor.GetRedUC(),
        m_Config->m_bgColor.GetGreenUC(),
        m_Config->m_bgColor.GetBlueUC(),
        m_Config->m_bgColor.GetAlphaUC());
    m_bgColor->SetColour(color);
}


void CHistConfigDlg::OnBGColorChanged( wxColourPickerEvent& event )
{
    wxColor color = m_bgColor->GetColour();
    m_Config->m_bgColor.Set(
        color.Red(),
        color.Green(),
        color.Blue(),
        (unsigned char)m_Opacity->GetValue());
    color.Set(m_Config->m_bgColor.GetRedUC(),
        m_Config->m_bgColor.GetGreenUC(),
        m_Config->m_bgColor.GetBlueUC(),
        m_Config->m_bgColor.GetAlphaUC());
    m_bgColor->SetColour(color);
}


void CHistConfigDlg::OnShowRulerClick( wxCommandEvent& event )
{
    m_Config->m_NeedRuler = !m_Config->m_NeedRuler;
    m_RulerColorGroup->Show(m_Config->m_NeedRuler);
    Layout();
    Refresh();
}


void CHistConfigDlg::OnDrawBackgroundClick( wxCommandEvent& event )
{
    m_Config->m_DrawBg = !m_Config->m_DrawBg;
    m_BgColorGroup->Show(m_Config->m_DrawBg);
    Layout();
    Refresh();
}



END_NCBI_SCOPE
