/*  $Id: wx_histogram_config_dlg.hpp 26805 2012-11-08 19:40:47Z wuliangs $
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 * Authors:  Liangshou Wu
 *
 * File Description:
 *
 */
// Generated by DialogBlocks (unregistered), 01/12/2008 09:18:04

#ifndef _HISTOGRAM_CONFIG_DLG_H_
#define _HISTOGRAM_CONFIG_DLG_H_


/*!
 * Includes
 */
#include <corelib/ncbiobj.hpp>
#include <string>
#include <gui/widgets/seq_graphic/histogram_conf.hpp>

////@begin includes
#include "wx/statline.h"
#include "wx/valgen.h"
#include "wx/clrpicker.h"
////@end includes
#include <wx/dialog.h>

/*!
 * Forward declarations
 */

////@begin forward declarations
class wxColourPickerCtrl;
class wxBoxSizer;
////@end forward declarations
class wxSlider;
class wxRadioButton;
class wxStaticText;


BEGIN_NCBI_SCOPE


/*!
 * Control identifiers
 */

////@begin control identifiers
#define ID_CHISTCONFIGDLG 10020
#define ID_RADIOBUTTON1 10021
#define ID_RADIOBUTTON2 10022
#define ID_RADIOBUTTON3 10023
#define ID_CHECKBOX5 10018
#define ID_CHECKBOX4 10017
#define ID_TEXTCTRL2 10024
#define ID_COLOURPICKERCTRL4 10026
#define ID_COLOURPICKERCTRL3 10025
#define ID_SLIDER1 10014
#define ID_COLOURPICKERCTRL5 10027
#define ID_COLOURPICKERCTRL8 10016
#define ID_COLOURPICKERCTRL6 10028
#define ID_COLOURPICKERCTRL7 10029
#define SYMBOL_CHISTCONFIGDLG_STYLE wxCAPTION|wxRESIZE_BORDER|wxSYSTEM_MENU|wxCLOSE_BOX|wxTAB_TRAVERSAL
#define SYMBOL_CHISTCONFIGDLG_TITLE _("Histogram Rendering Options")
#define SYMBOL_CHISTCONFIGDLG_IDNAME ID_CHISTCONFIGDLG
#define SYMBOL_CHISTCONFIGDLG_SIZE wxSize(400, 460)
#define SYMBOL_CHISTCONFIGDLG_POSITION wxDefaultPosition
////@end control identifiers


/*!
 * CHistConfigDlg class declaration
 */

class CHistConfigDlg: public wxDialog
{    
    DECLARE_DYNAMIC_CLASS( CHistConfigDlg )
    DECLARE_EVENT_TABLE()

public:
    CHistConfigDlg();
    CHistConfigDlg( wxWindow* parent, wxWindowID id = SYMBOL_CHISTCONFIGDLG_IDNAME, const wxString& caption = SYMBOL_CHISTCONFIGDLG_TITLE, const wxPoint& pos = SYMBOL_CHISTCONFIGDLG_POSITION, const wxSize& size = SYMBOL_CHISTCONFIGDLG_SIZE, long style = SYMBOL_CHISTCONFIGDLG_STYLE );

    bool CreateX( wxWindow* parent, wxWindowID id = SYMBOL_CHISTCONFIGDLG_IDNAME, const wxString& caption = SYMBOL_CHISTCONFIGDLG_TITLE, const wxPoint& pos = SYMBOL_CHISTCONFIGDLG_POSITION, const wxSize& size = SYMBOL_CHISTCONFIGDLG_SIZE, long style = SYMBOL_CHISTCONFIGDLG_STYLE );

    ~CHistConfigDlg();

    void Init();

    void CreateControls();

////@begin CHistConfigDlg event handler declarations

    void OnSmearBarSelected( wxCommandEvent& event );

    void OnHistogramSelected( wxCommandEvent& event );

    void OnLineGraphSelected( wxCommandEvent& event );

    void OnShowRulerClick( wxCommandEvent& event );

    void OnDrawBackgroundClick( wxCommandEvent& event );

    void OnHeightUpdated( wxCommandEvent& event );

    void OnBGColorChanged( wxColourPickerEvent& event );

    void OnOpacityUpdated( wxCommandEvent& event );

////@end CHistConfigDlg event handler declarations

////@begin CHistConfigDlg member function declarations

    wxBitmap GetBitmapResource( const wxString& name );

    wxIcon GetIconResource( const wxString& name );
////@end CHistConfigDlg member function declarations

    static bool ShowToolTips();
    void SetConfig(CRef<CHistParams> config);
    void SetConfigName(const string& name) { m_ConfName = name; }

    CRef<CHistParams> GetConfig() const { return m_Config; }

////@begin CHistConfigDlg member variables
    wxStaticText* m_HistName;
    wxRadioButton* m_SmearBar;
    wxRadioButton* m_Histogram;
    wxRadioButton* m_LineGraph;
    wxTextCtrl* m_Height;
    wxStaticBox* m_ColorBox;
    wxColourPickerCtrl* m_fgColor;
    wxBoxSizer* m_BgColorGroup;
    wxColourPickerCtrl* m_bgColor;
    wxSlider* m_Opacity;
    wxBoxSizer* m_RulerColorGroup;
    wxColourPickerCtrl* m_LabelColor;
    wxBoxSizer* m_SmearColorGroup;
    wxColourPickerCtrl* m_ColorMin;
    wxColourPickerCtrl* m_ColorMax;
////@end CHistConfigDlg member variables

private:
    CRef<CHistParams>  m_Config;
    string m_ConfName;
};

END_NCBI_SCOPE

#endif
    // _HISTOGRAM_CONFIG_DLG_H_
