/////////////////////////////////////////////////////////////////////////////
// Name:        demo_tablectrl_frame.hpp
// Purpose:
// Author:      Yury Voronov
// Modified by:
// Created:     30/08/2007 16:15:41
// RCS-ID:
// Copyright:
// Licence:
/////////////////////////////////////////////////////////////////////////////

#ifndef _DEMO_TABLECTRL_FRAME_H_
#define _DEMO_TABLECTRL_FRAME_H_

/*!
 * Includes
 */

////@begin includes
#include "wx/frame.h"
#include "wx/listctrl.h"
////@end includes

#include <corelib/ncbiobj.hpp>
#include <objmgr/object_manager.hpp>
#include <gui/widgets/feat_table/feat_table_ds.hpp>

/*!
 * Forward declarations
 */

BEGIN_NCBI_SCOPE
////@begin forward declarations
class CwxTableListCtrl;
////@end forward declarations
END_NCBI_SCOPE

/*!
 * Control identifiers
 */

////@begin control identifiers
#define ID_CWXDEMOTABLECTRLFRAME 10000
#define wxID_LOAD 10002
#define ID_TABLECTRL 10001
#define SYMBOL_CWXDEMOTABLECTRLFRAME_STYLE wxCAPTION|wxRESIZE_BORDER|wxSYSTEM_MENU|wxCLOSE_BOX
#define SYMBOL_CWXDEMOTABLECTRLFRAME_TITLE _("Table-to-ListCtrl")
#define SYMBOL_CWXDEMOTABLECTRLFRAME_IDNAME ID_CWXDEMOTABLECTRLFRAME
#define SYMBOL_CWXDEMOTABLECTRLFRAME_SIZE wxSize(400, 300)
#define SYMBOL_CWXDEMOTABLECTRLFRAME_POSITION wxDefaultPosition
////@end control identifiers


/*!
 * CwxDemoTableCtrlFrame class declaration
 */

class CwxDemoTableCtrlFrame: public wxFrame
{
    DECLARE_CLASS( CwxDemoTableCtrlFrame )
    DECLARE_EVENT_TABLE()

public:
    /// Constructors
    CwxDemoTableCtrlFrame();
    CwxDemoTableCtrlFrame( wxWindow* parent, wxWindowID id = SYMBOL_CWXDEMOTABLECTRLFRAME_IDNAME, const wxString& caption = SYMBOL_CWXDEMOTABLECTRLFRAME_TITLE, const wxPoint& pos = SYMBOL_CWXDEMOTABLECTRLFRAME_POSITION, const wxSize& size = SYMBOL_CWXDEMOTABLECTRLFRAME_SIZE, long style = SYMBOL_CWXDEMOTABLECTRLFRAME_STYLE );

    bool Create( wxWindow* parent, wxWindowID id = SYMBOL_CWXDEMOTABLECTRLFRAME_IDNAME, const wxString& caption = SYMBOL_CWXDEMOTABLECTRLFRAME_TITLE, const wxPoint& pos = SYMBOL_CWXDEMOTABLECTRLFRAME_POSITION, const wxSize& size = SYMBOL_CWXDEMOTABLECTRLFRAME_SIZE, long style = SYMBOL_CWXDEMOTABLECTRLFRAME_STYLE );

    /// Destructor
    ~CwxDemoTableCtrlFrame();

    /// Initialises member variables
    void Init();

    /// Creates the controls and sizers
    void CreateControls();

////@begin CwxDemoTableCtrlFrame event handler declarations

    /// wxEVT_COMMAND_MENU_SELECTED event handler for wxID_OPEN
    void OnOpenClick( wxCommandEvent& event );

    /// wxEVT_COMMAND_MENU_SELECTED event handler for wxID_LOAD
    void OnLoadClick( wxCommandEvent& event );

////@end CwxDemoTableCtrlFrame event handler declarations

////@begin CwxDemoTableCtrlFrame member function declarations

    wxString GetAccession() const { return m_Accession ; }
    void SetAccession(wxString value) { m_Accession = value ; }

    ncbi::CRef<ncbi::objects::CObjectManager> GetObjectManager() const { return m_ObjectManager ; }
    void SetObjectManager(ncbi::CRef<ncbi::objects::CObjectManager> value) { m_ObjectManager = value ; }

    /// Retrieves bitmap resources
    wxBitmap GetBitmapResource( const wxString& name );

    /// Retrieves icon resources
    wxIcon GetIconResource( const wxString& name );
////@end CwxDemoTableCtrlFrame member function declarations

    bool LoadAccession( const wxString& anAccName );
    bool LoadFile( const wxString& aFileName );

    /// Should we show tooltips?
    static bool ShowToolTips();

////@begin CwxDemoTableCtrlFrame member variables
    ncbi::CwxTableListCtrl* m_TableCtrl;
private:
    wxString m_Accession;
    ncbi::CFeatTableDS m_DataSource;
    ncbi::CRef<ncbi::objects::CObjectManager> m_ObjectManager;
////@end CwxDemoTableCtrlFrame member variables
};

#endif
    // _DEMO_TABLECTRL_FRAME_H_
