/*  $Id: text_report_dlg.cpp 25496 2012-03-27 20:41:38Z kuznets $
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data,  the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties,  express or implied,  including
 *  warranties of performance,  merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 * Authors:  Roman Katargin
 */


#include <ncbi_pch.hpp>

////@begin includes
////@end includes

#include <gui/widgets/wx/text_report_dlg.hpp>

#include <wx/sizer.h>
#include <wx/button.h>
#include <wx/icon.h>
#include <wx/textctrl.h>

BEGIN_NCBI_SCOPE

////@begin XPM images
////@end XPM images


/*!
 * CTextReportDlg type definition
 */

IMPLEMENT_DYNAMIC_CLASS( CTextReportDlg, wxDialog )


/*!
 * CTextReportDlg event table definition
 */

BEGIN_EVENT_TABLE( CTextReportDlg, wxDialog )

////@begin CTextReportDlg event table entries
////@end CTextReportDlg event table entries

END_EVENT_TABLE()


/*!
 * CTextReportDlg constructors
 */

CTextReportDlg::CTextReportDlg()
{
    Init();
}

CTextReportDlg::CTextReportDlg( wxWindow* parent, wxWindowID id, const wxString& caption, const wxPoint& pos, const wxSize& size, long style )
{
    Init();
    Create(parent, id, caption, pos, size, style);
}


/*!
 * CTextReportDlg creator
 */

bool CTextReportDlg::Create( wxWindow* parent, wxWindowID id, const wxString& caption, const wxPoint& pos, const wxSize& size, long style )
{
////@begin CTextReportDlg creation
    SetExtraStyle(wxWS_EX_BLOCK_EVENTS);
    wxDialog::Create( parent, id, caption, pos, size, style );

    CreateControls();
    if (GetSizer())
    {
        GetSizer()->SetSizeHints(this);
    }
    Centre();
////@end CTextReportDlg creation
    return true;
}


/*!
 * CTextReportDlg destructor
 */

CTextReportDlg::~CTextReportDlg()
{
////@begin CTextReportDlg destruction
////@end CTextReportDlg destruction
}


/*!
 * Member initialisation
 */

void CTextReportDlg::Init()
{
////@begin CTextReportDlg member initialisation
////@end CTextReportDlg member initialisation
}


/*!
 * Control creation for CTextReportDlg
 */

void CTextReportDlg::CreateControls()
{
////@begin CTextReportDlg content construction
    CTextReportDlg* itemDialog1 = this;

    wxBoxSizer* itemBoxSizer2 = new wxBoxSizer(wxVERTICAL);
    itemDialog1->SetSizer(itemBoxSizer2);

    wxTextCtrl* itemTextCtrl3 = new wxTextCtrl( itemDialog1, ID_TEXTCTRL1, wxT(""), wxDefaultPosition, itemDialog1->ConvertDialogToPixels(wxSize(300, 200)), wxTE_MULTILINE|wxTE_READONLY );
    itemBoxSizer2->Add(itemTextCtrl3, 1, wxGROW|wxALL, 5);

    wxBoxSizer* itemBoxSizer4 = new wxBoxSizer(wxHORIZONTAL);
    itemBoxSizer2->Add(itemBoxSizer4, 0, wxALIGN_CENTER_HORIZONTAL|wxALL, 5);

    wxButton* itemButton5 = new wxButton( itemDialog1, wxID_OK, wxT("OK"), wxDefaultPosition, wxDefaultSize, 0 );
    itemBoxSizer4->Add(itemButton5, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5);

    // Set validators
    itemTextCtrl3->SetValidator( wxTextValidator(wxFILTER_NONE, & m_Text) );
////@end CTextReportDlg content construction
}


/*!
 * Should we show tooltips?
 */

bool CTextReportDlg::ShowToolTips()
{
    return true;
}

/*!
 * Get bitmap resources
 */

wxBitmap CTextReportDlg::GetBitmapResource( const wxString& name )
{
    // Bitmap retrieval
////@begin CTextReportDlg bitmap retrieval
    wxUnusedVar(name);
    return wxNullBitmap;
////@end CTextReportDlg bitmap retrieval
}

/*!
 * Get icon resources
 */

wxIcon CTextReportDlg::GetIconResource( const wxString& name )
{
    // Icon retrieval
////@begin CTextReportDlg icon retrieval
    wxUnusedVar(name);
    return wxNullIcon;
////@end CTextReportDlg icon retrieval
}

END_NCBI_SCOPE
