#include <cstring>
#include <iostream>
#include <fstream>

using namespace std;

bool match(istream& f1, istream& f2)
{
    const int BufSize = 500000000;
    static char b1[BufSize];
    static char b2[BufSize];
    unsigned long idx = 0;
    
    while (true)
    {
        f1.read(b1, BufSize);
        f2.read(b2, BufSize);
        if (f1.gcount() != f2.gcount())
        {
            cout << "file sizes differ " << endl;
            return false;
        }
        
        if (memcmp(b1, b2, f1.gcount())) 
        {
            cout << "files do not match after " << idx << endl;
            return false;
        }
        
        idx += f1.gcount();
        
        if (!f1 && !f2)
        {
            cout << "files match" << endl;
            return true;
        }
        
        cout << idx/1000000 << "M" << endl;
    } 
}

int 
main(int argc, char *argv[] )
{
    if (argc == 3)
    {
        ifstream f1(argv[1]);
        if (f1)
        {
            ifstream f2(argv[2]);
            if (f2)
                return match(f1, f2) ? 0 : 1;
            else
                cout << "error opening file 2 " << argv[2] << endl;
        }
        else
            cout << "error opening file 1 " << argv[1] << endl;
    }
    else
        cout << "require 2 arguments, not " << argc-1 << endl;
}