#ifndef GUI_PACKAGES_PKG_SNP___TM_NOTICE_JOB__HPP
#define GUI_PACKAGES_PKG_SNP___TM_NOTICE_JOB__HPP

/*  $Id: job_update.hpp 18397 2008-11-28 19:45:17Z dicuccio $
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 * Authors:  Melvin Quintos
 *
 * File Description: Data model interface for CTableModelJobNotice
 *
 */


BEGIN_NCBI_SCOPE

#include <gui/framework/observable.hpp>
#include <gui/utils/app_job.hpp>

class CJobUpdate: public CObserverUpdate
{
public:
    CJobUpdate(IObservable* source, int job_id,
                         IAppJob::EJobState state, const string& msg)
     : CObserverUpdate(eStateChanged, source), m_nJobID(job_id)
     , m_eState(state), m_strMessage(msg)
    {
    }

    int                 GetJobID() const    { return m_nJobID; }
    IAppJob::EJobState  GetJobState() const { return m_eState; }
    const string&       GetMessage() const  { return m_strMessage; }

private:
    int                 m_nJobID;
    IAppJob::EJobState  m_eState;
    string              m_strMessage;
};

END_NCBI_SCOPE

#endif // GUI_PACKAGES_PKG_SNP___TM_NOTICE_JOB__HPP
