#ifndef GUI_WIDGETS_SNP_FILTER___ALGO_TRACK_CREATOR__HPP
#define GUI_WIDGETS_SNP_FILTER___ALGO_TRACK_CREATOR__HPP

/*  $Id: algo_track_creator.hpp 16579 2008-04-02 13:20:08Z dicuccio $
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 * Authors:  Melvin Quintos
 *
 * File Description:
 *    Algo plugin to launch a dialog for creating filtered snp tracks
 *
 */

#include <gui/core/algo_plugin.hpp>


BEGIN_NCBI_SCOPE

class CAlgoPlugin_CreateTrackCreatorDialog
    : public CAlgoPlugin<CAlgoPlugin_CreateTrackCreatorDialog>
{
public:
    CAlgoPlugin_CreateTrackCreatorDialog();
    ~CAlgoPlugin_CreateTrackCreatorDialog();

    void Run(objects::CPluginMessage& msg);

    static void GetInfo(objects::CPluginInfoSet& info);

private:
    CAlgoPlugin_CreateTrackCreatorDialog(const CAlgoPlugin_CreateTrackCreatorDialog&);
    CAlgoPlugin_CreateTrackCreatorDialog& operator=(const CAlgoPlugin_CreateTrackCreatorDialog&);
};


END_NCBI_SCOPE


#endif  // GUI_WIDGETS_SNP_FILTER___ALGO_TRACK_CREATOR__HPP

