#ifndef GUI_WIDGETS_SNP___GROUP_CHECKBOXES_HPP
#define GUI_WIDGETS_SNP___GROUP_CHECKBOXES_HPP

/*  $Id: group_checkboxes.hpp 17877 2008-09-24 13:03:09Z dicuccio $
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 * Authors:  Melvin Quintos
 *
 * File Description:
 *
 */

#include <corelib/ncbistd.hpp>
#include <gui/gui.hpp>

#include <set>
#include <map>

#include <wx/event.h>

class wxWindow;

BEGIN_NCBI_SCOPE

class CGroupCheckboxes : public wxEvtHandler
{
public:

    CGroupCheckboxes( wxWindow * parent, int x, int y, int width, int height);
    void Add(int id, const char * text);
    void GetCheckList(list<int> *list_checked);

    void SetCheck(int id, bool value);
    void SetCheck(wxWindow*, bool);     // called by gui callback handler

    bool HasChanges() const; // returns true only if SetCheck(Fl_Widget*,bool) was called

    void OnClick( wxCommandEvent & evt );

    void Reset();



private:
    bool m_bHasUIChanges;

    int  m_nX, m_nY, m_nWidth, m_nHeight;
    int  m_nCurrentY;

    wxWindow *              m_pParent;
    map<wxWindow*, int>     m_mapButtons;
    map<int, wxWindow*>     m_mapIDs;
    set<int>                m_setChecked;


};

END_NCBI_SCOPE

#endif // GUI_WIDGETS_SNP___GROUP_CHECKBOXES_HPP

