/*  $Id: rename_dlg.cpp 25491 2012-03-27 17:52:21Z kuznets $
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data,  the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties,  express or implied,  including
 *  warranties of performance,  merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 * Authors:  Melvin Quintos
 *
 * File Description:
 *
 */

#include <ncbi_pch.hpp>

////@begin includes
////@end includes

#include <wx/bitmap.h>
#include <wx/sizer.h>
#include <wx/button.h>
#include <wx/icon.h>

#include "rename_dlg.hpp"

////@begin XPM images
////@end XPM images

BEGIN_NCBI_SCOPE

/*!
 * CRenameDlg type definition
 */

IMPLEMENT_DYNAMIC_CLASS( CRenameDlg, wxDialog )


/*!
 * CRenameDlg event table definition
 */

BEGIN_EVENT_TABLE( CRenameDlg, wxDialog )

////@begin CRenameDlg event table entries
////@end CRenameDlg event table entries

END_EVENT_TABLE()


/*!
 * CRenameDlg constructors
 */

CRenameDlg::CRenameDlg()
{
    Init();
}

CRenameDlg::CRenameDlg( wxWindow* parent, wxWindowID id, const wxString& caption, const wxPoint& pos, const wxSize& size, long style )
{
    Init();
    CreateX(wxString(), parent, id, caption, pos, size, style);
}


/*!
 * CRenameDlg creator
 */

bool CRenameDlg::CreateX( const wxString &text, wxWindow* parent, wxWindowID id, const wxString& caption, const wxPoint& pos, const wxSize& size, long style )
{
////@begin CRenameDlg creation
    SetExtraStyle(wxWS_EX_BLOCK_EVENTS);
    wxDialog::Create( parent, id, caption, pos, size, style );

    CreateControls();
    if (GetSizer())
    {
        GetSizer()->SetSizeHints(this);
    }
    Centre();
////@end CRenameDlg creation
    Text->SetValue(text);
    return true;
}


/*!
 * CRenameDlg destructor
 */

CRenameDlg::~CRenameDlg()
{
////@begin CRenameDlg destruction
////@end CRenameDlg destruction
}


/*!
 * Member initialisation
 */

void CRenameDlg::Init()
{
////@begin CRenameDlg member initialisation
    Text = NULL;
////@end CRenameDlg member initialisation
}


/*!
 * Control creation for CRenameDlg
 */

void CRenameDlg::CreateControls()
{
////@begin CRenameDlg content construction
    CRenameDlg* itemDialog1 = this;

    wxBoxSizer* itemBoxSizer2 = new wxBoxSizer(wxHORIZONTAL);
    itemDialog1->SetSizer(itemBoxSizer2);

    Text = new wxTextCtrl( itemDialog1, ID_TEXTCTRL, wxT(""), wxDefaultPosition, wxSize(210, -1), 0 );
    itemBoxSizer2->Add(Text, 1, wxALIGN_CENTER_VERTICAL|wxALL, 5);

    wxStdDialogButtonSizer* itemStdDialogButtonSizer4 = new wxStdDialogButtonSizer;

    itemBoxSizer2->Add(itemStdDialogButtonSizer4, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5);
    wxButton* itemButton5 = new wxButton( itemDialog1, wxID_OK, wxT("&OK"), wxDefaultPosition, wxDefaultSize, 0 );
    itemStdDialogButtonSizer4->AddButton(itemButton5);

    wxButton* itemButton6 = new wxButton( itemDialog1, wxID_CANCEL, wxT("&Cancel"), wxDefaultPosition, wxDefaultSize, 0 );
    itemStdDialogButtonSizer4->AddButton(itemButton6);

    itemStdDialogButtonSizer4->Realize();

////@end CRenameDlg content construction
}


/*!
 * Should we show tooltips?
 */

bool CRenameDlg::ShowToolTips()
{
    return true;
}

/*!
 * Get bitmap resources
 */

wxBitmap CRenameDlg::GetBitmapResource( const wxString& name )
{
    // Bitmap retrieval
////@begin CRenameDlg bitmap retrieval
    wxUnusedVar(name);
    return wxNullBitmap;
////@end CRenameDlg bitmap retrieval
}

/*!
 * Get icon resources
 */

wxIcon CRenameDlg::GetIconResource( const wxString& name )
{
    // Icon retrieval
////@begin CRenameDlg icon retrieval
    wxUnusedVar(name);
    return wxNullIcon;
////@end CRenameDlg icon retrieval
}

END_NCBI_SCOPE
