/*  $Id: rename_dlg.hpp 25491 2012-03-27 17:52:21Z kuznets $
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data,  the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties,  express or implied,  including
 *  warranties of performance,  merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 * Authors:  Melvin Quintos
 *
 * File Description:
 *
 */

#ifndef _RENAME_DLG_H_
#define _RENAME_DLG_H_

#include <corelib/ncbistd.hpp>

/*!
 * Includes
 */

#include <wx/dialog.h>
#include <wx/textctrl.h>

////@begin includes
////@end includes

/*!
 * Forward declarations
 */

////@begin forward declarations
////@end forward declarations

/*!
 * Control identifiers
 */

////@begin control identifiers
#define SYMBOL_CRENAMEDLG_STYLE wxCAPTION|wxRESIZE_BORDER|wxSYSTEM_MENU|wxCLOSE_BOX|wxTAB_TRAVERSAL
#define SYMBOL_CRENAMEDLG_TITLE wxT("Rename Filter")
#define SYMBOL_CRENAMEDLG_IDNAME ID_CRENAMEDLG
#define SYMBOL_CRENAMEDLG_SIZE wxSize(400, 300)
#define SYMBOL_CRENAMEDLG_POSITION wxDefaultPosition
////@end control identifiers


BEGIN_NCBI_SCOPE

/*!
 * CRenameDlg class declaration
 */

class CRenameDlg: public wxDialog
{
    DECLARE_DYNAMIC_CLASS( CRenameDlg )
    DECLARE_EVENT_TABLE()

public:
    /// Constructors
    CRenameDlg();
    CRenameDlg( wxWindow* parent, wxWindowID id = SYMBOL_CRENAMEDLG_IDNAME, const wxString& caption = SYMBOL_CRENAMEDLG_TITLE, const wxPoint& pos = SYMBOL_CRENAMEDLG_POSITION, const wxSize& size = SYMBOL_CRENAMEDLG_SIZE, long style = SYMBOL_CRENAMEDLG_STYLE );

    /// Creation
    bool CreateX( const wxString &text = wxString(), wxWindow* parent=0, wxWindowID id = SYMBOL_CRENAMEDLG_IDNAME, const wxString& caption = SYMBOL_CRENAMEDLG_TITLE, const wxPoint& pos = SYMBOL_CRENAMEDLG_POSITION, const wxSize& size = SYMBOL_CRENAMEDLG_SIZE, long style = SYMBOL_CRENAMEDLG_STYLE );

    /// Destructor
    ~CRenameDlg();

    /// Initialises member variables
    void Init();

    /// Creates the controls and sizers
    void CreateControls();

////@begin CRenameDlg event handler declarations

////@end CRenameDlg event handler declarations

////@begin CRenameDlg member function declarations

    /// Retrieves bitmap resources
    wxBitmap GetBitmapResource( const wxString& name );

    /// Retrieves icon resources
    wxIcon GetIconResource( const wxString& name );
////@end CRenameDlg member function declarations

    /// Should we show tooltips?
    static bool ShowToolTips();

////@begin CRenameDlg member variables
    wxTextCtrl* Text;
    /// Control identifiers
    enum {
        ID_CRENAMEDLG = 10012,
        ID_TEXTCTRL = 10013
    };
////@end CRenameDlg member variables
};

END_NCBI_SCOPE

#endif // _RENAME_DLG_H_

