#ifndef GUI_WIDGETS_SNP_FILTER___SNP_FILTER_JOB__HPP
#define GUI_WIDGETS_SNP_FILTER___SNP_FILTER_JOB__HPP

#include <gui/types.hpp>

#include <gui/utils/app_job.hpp>
#include <gui/utils/app_job_impl.hpp>

#include <objmgr/scope.hpp>
#include <objects/seqloc/Seq_loc.hpp>
#include <gui/widgets/snp/filter/snp_filter.hpp>

/////////////////////////////////////////////////////////////////////////////
///
///  Alignment-based data source
///

BEGIN_NCBI_SCOPE
BEGIN_objects_SCOPE

class CSeq_graph;

class CSnpFilterJob : public CJobCancelable
{
public:
    CSnpFilterJob( CScope& scope, CSeq_loc& loc, const SSnpFilter& filter );

    /// @name IAppJob implementation
    /// @{
    virtual EJobState                   Run();
    virtual CConstIRef<IAppJobProgress> GetProgress();
    virtual CRef<CObject>               GetResult();
    virtual CConstIRef<IAppJobError>    GetError();
    virtual string                      GetDescr() const;
    /// @}

protected:

    CRef<CScope>        m_Scope;
    CRef<CSeq_loc>      m_Loc;
    CRef<SSnpFilter>    m_Filter;

    /// for status reporting
    size_t m_Total;
    size_t m_Completed;

    // for job results/status
    CRef<CAppJobError>  m_Error;
    CRef<CSeq_graph>    m_Result;
};

END_objects_SCOPE
END_NCBI_SCOPE

#endif // GUI_WIDGETS_SNP_FILTER___SNP_FILTER_JOB__HPP

