/*  $Id: snp_filter_ui_clear.cpp 25491 2012-03-27 17:52:21Z kuznets $
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 * Authors:  Melvin Quintos
 *
 * File Description:
 *
 */

#include <ncbi_pch.hpp>

#include <gui/widgets/snp/filter/snp_filter_ui.hpp>
#include <gui/widgets/snp/filter/group_checkboxes.hpp>
#include <gui/widgets/snp/filter/group_radios.hpp>

#include <gui/widgets/wx/wx_utils.hpp>


BEGIN_NCBI_SCOPE

// Removes all SNP Filters
void CSnpFilterUI::x_Clear()
{
    // Record the names of all the filters that were modified
    NON_CONST_ITERATE(TMapFilters, iter, m_mapFilters) {
        const string &name = iter->first;
        m_mapChangeInfo[name] = eDeleted;
    }
    
    m_Browser->Clear();
    m_mapFilters.clear();
    m_nSelectedRow = wxNOT_FOUND;
    m_FilterPane->SetLabel(wxT("<no filter selected>"));
}

END_NCBI_SCOPE
