/*  $Id: gwas_track_load_params.cpp 19268 2009-05-13 14:28:25Z quintosm $
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data,  the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties,  express or implied,  including
 *  warranties of performance,  merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 * Authors:  Melvin Quintos
 */


#include <ncbi_pch.hpp>

////@begin includes
#include "../../../../../include/gui/packages/pkg_snp/gwas_track_load_params.hpp"

////@end includes

BEGIN_NCBI_SCOPE

/*!
 * GwasLoadParams type definition
 */

/*!
 * Default constructor for GwasLoadParams
 */

CGwasLoadParams::CGwasLoadParams()
{
    Init();
}

/*!
 * Copy constructor for GwasLoadParams
 */

CGwasLoadParams::CGwasLoadParams(const CGwasLoadParams& data)
{
    Init();
    Copy(data);
}

/*!
 * Destructor for GwasLoadParams
 */

CGwasLoadParams::~CGwasLoadParams()
{
}

/*!
 * Assignment operator for GwasLoadParams
 */

void CGwasLoadParams::operator=(const CGwasLoadParams& data)
{
    Copy(data);
}

/*!
 * Equality operator for GwasLoadParams
 */

bool CGwasLoadParams::operator==(const CGwasLoadParams& data) const
{
////@begin CGwasLoadParams equality operator
     if (!(m_sTitle == data.m_sTitle)) return false;
     if (!(m_eTrackType == data.m_eTrackType)) return false;
////@end CGwasLoadParams equality operator
    return true;
}

/*!
 * Copy function for GwasLoadParams
 */

void CGwasLoadParams::Copy(const CGwasLoadParams& data)
{
////@begin CGwasLoadParams copy function
    m_sTitle = data.m_sTitle;
    m_eTrackType = data.m_eTrackType;
////@end CGwasLoadParams copy function
}

/*!
 * Member initialisation for GwasLoadParams
 */

void CGwasLoadParams::Init()
{
////@begin CGwasLoadParams member initialisation
////@end CGwasLoadParams member initialisation
}


void CGwasLoadParams::SaveSettings() const
{

}

void CGwasLoadParams::LoadSettings()
{

}

END_NCBI_SCOPE
