/*  $Id: gwas_track_params_panel.hpp 23953 2011-06-23 19:29:53Z wuliangs $
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data,  the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties,  express or implied,  including
 *  warranties of performance,  merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 * Authors:  Melvin Quintos
 */
#ifndef _GWAS_TRACK_PARAMS_PANEL_H_
#define _GWAS_TRACK_PARAMS_PANEL_H_

#include <corelib/ncbistd.hpp>

/*!
 * Includes
 */

////@begin includes
#include "../../../../../include/gui/packages/pkg_snp/gwas_track_load_params.hpp"
#include "wx/valgen.h"
////@end includes

#include <wx/panel.h>

/*!
 * Forward declarations
 */

////@begin forward declarations
////@end forward declarations

/*!
 * Control identifiers
 */

////@begin control identifiers
#define SYMBOL_CGWASTRACKPARAMSPANEL_STYLE wxTAB_TRAVERSAL
#define SYMBOL_CGWASTRACKPARAMSPANEL_TITLE _("GWAS Track Params Panel")
#define SYMBOL_CGWASTRACKPARAMSPANEL_IDNAME ID_GWASTRACKPARAMSPANEL
#define SYMBOL_CGWASTRACKPARAMSPANEL_SIZE wxSize(600, 300)
#define SYMBOL_CGWASTRACKPARAMSPANEL_POSITION wxDefaultPosition
////@end control identifiers

BEGIN_NCBI_SCOPE

/*!
 * CGwasTrackParamsPanel class declaration
 */

class CGwasTrackParamsPanel: public wxPanel
{
    DECLARE_DYNAMIC_CLASS( CGwasTrackParamsPanel )
    DECLARE_EVENT_TABLE()

public:
    /// Constructors
    CGwasTrackParamsPanel();
    CGwasTrackParamsPanel( wxWindow* parent, wxWindowID id = SYMBOL_CGWASTRACKPARAMSPANEL_IDNAME, const wxPoint& pos = SYMBOL_CGWASTRACKPARAMSPANEL_POSITION, const wxSize& size = SYMBOL_CGWASTRACKPARAMSPANEL_SIZE, long style = SYMBOL_CGWASTRACKPARAMSPANEL_STYLE );

    /// Creation
    bool CreateX( wxWindow* parent, wxWindowID id = SYMBOL_CGWASTRACKPARAMSPANEL_IDNAME, const wxPoint& pos = SYMBOL_CGWASTRACKPARAMSPANEL_POSITION, const wxSize& size = SYMBOL_CGWASTRACKPARAMSPANEL_SIZE, long style = SYMBOL_CGWASTRACKPARAMSPANEL_STYLE );

    /// Destructor
    ~CGwasTrackParamsPanel();

    /// Initialises member variables
    void Init();

    /// Creates the controls and sizers
    void CreateControls();

    /// Transfer data to the window
    virtual bool TransferDataToWindow();

    /// Transfer data from the window
    virtual bool TransferDataFromWindow();

////@begin CGwasTrackParamsPanel event handler declarations

////@end CGwasTrackParamsPanel event handler declarations

////@begin CGwasTrackParamsPanel member function declarations

    /// Data access
    CGwasLoadParams& GetData() { return m_data; }
    const CGwasLoadParams& GetData() const { return m_data; }
    void SetData(const CGwasLoadParams& data) { m_data = data; }

    /// Retrieves bitmap resources
    wxBitmap GetBitmapResource( const wxString& name );

    /// Retrieves icon resources
    wxIcon GetIconResource( const wxString& name );
////@end CGwasTrackParamsPanel member function declarations

    /// Should we show tooltips?
    static bool ShowToolTips();

////@begin CGwasTrackParamsPanel member variables
    /// The data edited by this window
    CGwasLoadParams m_data;
    /// Control identifiers
    enum {
        ID_GWASTRACKPARAMSPANEL = 10000,
        ID_TEXTCTRL = 10001,
        ID_TEXTCTRL1 = 10002
    };
////@end CGwasTrackParamsPanel member variables

};

END_NCBI_SCOPE

#endif
    // _GWAS_TRACK_PARAMS_PANEL_H_
